<cfcomponent displayname="Jobing Book" >

    <cffunction name="init" access="public" returntype="JobbingBook" hint="initialize the component">
    	<cfargument name="dsn" required="yes" type="string" hint="Datasource name" />
        
        <cfset this.dsn = arguments.dsn> 
        
        <cfreturn this />
    </cffunction>  
   
    <cffunction name="GetTradeRate" access="public" returntype="query">
    	
        <cfquery name="qTemp" datasource="#this.dsn#">
        	SELECT * FROM sbo_trade_rate
        </cfquery>
               
        <cfreturn qTemp>
    </cffunction>
    
    <cffunction name="getCoreGLId" returntype="struct" access="public">
    	
        <cfset var stemp = StructNew()>
        <cfset var qtemp = "">
        
        <cfquery name="qtemp" datasource="#this.dsn#">
			SELECT GeneralLedgerId, Name FROM vw_acc_generalledger WHERE Name LIKE "*%"
        </cfquery>
        
        <cfset glnamelst = "Trading Bank,Withholding Tax,Own Client,SEC,VAT,Contract Stamp,Buy CSCS,Sell CSCS,PIF,NSE">
        <cfset gtitlelst = "TB,WT,OC,SEC,VAT,CS,BC,SC,PIF,NSE">
        <cfset i = 0>
        <cfloop list="#GLNamelst#" index="gln">
        	<cfset i = i + 1>
            <cfquery name="qtempF" dbtype="query">
            	SELECT * FROM qtemp WHERE Name = '* #gln# Account'
            </cfquery>
            <cfset stemp["#Listgetat(gtitlelst,i)#"] = qtempF.GeneralLedgerId > 
        </cfloop>
        
        <cfreturn stemp>
    </cffunction>
    
    <cffunction name="DeleteAllotment" access="public" returntype="string" 
    	hint="Delete Allotment Entry from the DB, and update the client account, Allotment Table, and account voucher.">
        <cfargument type="string" name="TicketId" required="yes">
        <cfargument type="string" name="Type" required="yes">
        <cfargument type="date" name="TransactionDate" required="yes">
        
        <cfset var sdate = dateformat(arguments.transactiondate,'yyyy/mm/dd')>
        <cfset var date_ = dateformat(arguments.transactiondate,'yyyy/mm/dd')>
        <cfset var date2_ = dateformat(arguments.transactiondate,'mmyydd')>
        
        <cfquery datasource="#this.dsn#" name="qtemp">
			SELECT * FROM sbo_allotment
            WHERE Type = <cfqueryparam value="#arguments.Type#" cfsqltype="cf_sql_varchar">
            	AND TransactionDate = <cfqueryparam value="#sdate#" cfsqltype="cf_sql_date">
                AND TicketId = <cfqueryparam value="#arguments.TicketId#" cfsqltype="cf_sql_varchar">        
        </cfquery>
        
        <cfif qtemp.RecordCount neq 0> 
            <cfset GL = getCoreGLId()>
            
            <cfquery datasource="#this.dsn#">
                DELETE FROM acc_voucher 
                WHERE RefNumber = "SL#date2_#" OR RefNumber = "BY#date2_#"
            </cfquery>
            
            <!--- sold --->
            <cfquery name="qSell" datasource="#this.dsn#">
                SELECT 
                    SUM(BuyCSCS) BuyCSCS, SUM(BuyCSCSVAT) BuyCSCSVAT, SUM(SellCSCS) SellCSCS,
                    SUM(SellCSCSVAT) SellCSCSVAT, SUM(NSECharges) NSECharges, SUM(Commission) Commission,
                    SUM(ContractStamp) ContractStamp, SUM(VAT) VAT, SUM(SEC) SEC, SUM(NetValue) NetValue,
                    SUM(TotalPrice) TotalPrice  
                FROM vw_sbo_allotment 
                WHERE Type = '2' AND TransactionDate = <cfqueryparam value="#date_#" cfsqltype="cf_sql_date">
            </cfquery>
            <cfquery name="qpif"  datasource="#this.dsn#"> 
                SELECT Sum(alt.NetValue) NetValue
                FROM sbo_allotment AS alt
                Inner Join sbo_cscs_account AS ca ON alt.CSCSAccountId = ca.CSCSAccountId
                Inner Join sbo_client AS scl ON ca.SBOClientId = scl.SBOClientId
                Inner Join sbo_account_type AS at ON scl.AccountTypeId = at.AccountTypeId
                WHERE at.Name LIKE  '* PIF%' AND alt.Type = '2' 
            </cfquery>
            <cfset stemp = "">
            <cfset nonpifNetVal = abs(val(qpif.NetValue)-qsell.NetValue)>
            <cfset stemp = ListAppend(stemp,'("SUMM-SELL FOR #date_#","0","#nonpifNetVal#","#GL.TB#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("COMM-SELL FOR #date_#","0","#qSell.Commission#","#GL.TB#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("TOTAL-SELL FOR #date_#","#qSell.TotalPrice#","0","#GL.OC#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("PIF CLIENT-SELL FOR #date_#","#val(qpif.NetValue)#","0","#GL.PIF#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("VAT-SELL FOR #date_#","0","#qSell.VAT#","#GL.VAT#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("STAMP-SELL FOR #date_#","0","#qSell.ContractStamp#","#GL.CS#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("NSE-SELL FOR #date_#","0","#qSell.NSECharges#","#GL.NSE#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("CSCS-SELL FOR #date_#","0","#qSell.SellCSCS+qSell.SellCSCSVAT#","#GL.SC#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("SEC-SELL FOR #date_#","0","#qSell.SEC#","#GL.SEC#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
            
            <!--- buy --->
            <cfquery name="qBuy" datasource="#this.dsn#">
                SELECT 
                    SUM(BuyCSCS) BuyCSCS, SUM(BuyCSCSVAT) BuyCSCSVAT, SUM(SellCSCS) SellCSCS,
                    SUM(SellCSCSVAT) SellCSCSVAT, SUM(NSECharges) NSECharges, SUM(Commission) Commission,
                    SUM(ContractStamp) ContractStamp, SUM(VAT) VAT, SUM(SEC) SEC, SUM(NetValue) NetValue,
                    SUM(TotalPrice) TotalPrice  
                FROM vw_sbo_allotment 
                WHERE Type = '1'  AND TransactionDate = <cfqueryparam value="#date_#" cfsqltype="cf_sql_date">
            </cfquery>
            <cfquery name="qpif" datasource="#this.dsn#"> 
                SELECT Sum(alt.NetValue) NetValue
                FROM sbo_allotment AS alt
                Inner Join sbo_cscs_account AS ca ON alt.CSCSAccountId = ca.CSCSAccountId
                Inner Join sbo_client AS scl ON ca.SBOClientId = scl.SBOClientId
                Inner Join sbo_account_type AS at ON scl.AccountTypeId = at.AccountTypeId
                WHERE at.Name LIKE  '* PIF%' AND alt.Type = '1'
            </cfquery>
            <cfset nonpifNetVal = abs(val(qpif.NetValue)-qbuy.NetValue)>
            <cfset stemp = ListAppend(stemp,'("SUMM-BUY FOR #date_#","#nonpifNetVal#","0","#GL.TB#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("COMM-BUY FOR #date_#","0","#qBuy.Commission#","#GL.TB#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("TOTAL-BUY FOR #date_#","0","#qBuy.TotalPrice#","#GL.OC#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("PIF CLIENT-BUY FOR #date_#","0","#val(qpif.NetValue)#","#GL.PIF#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("VAT-BUY FOR #date_#","0","#qBuy.VAT#","#GL.VAT#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("STAMP-BUY FOR #date_#","0","#qBuy.ContractStamp#","#GL.CS#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("NSE-BUY FOR #date_#","0","#qBuy.NSECharges#","#GL.NSE#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("CSCS-BUY FOR #date_#","0","#qBuy.BuyCSCS+qBuy.BuyCSCSVAT#","#GL.BC#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            <cfset stemp = ListAppend(stemp,'("SEC-BUY FOR #date_#","0","#qBuy.SEC#","#GL.SEC#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
            
            <cfquery datasource="#this.dsn#">
                INSERT INTO acc_voucher (Description, Debit, Credit, GeneralLedgerId, PostingDate, ValueDate, RefNumber, Note) 
                VALUES #stemp#
            </cfquery>
                
            <cfquery datasource="#this.dsn#">
                DELETE FROM sbo_client_account
                WHERE source = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.TicketId#">
                    AND TransactionDate = <cfqueryparam cfsqltype="cf_sql_date" value="#date_#"> 
                    AND <cfif arguments.Type eq 1> Credit = 0 <cfelse> Debit = 0</cfif>                
            </cfquery>
            <cfquery datasource="#this.dsn#">
                DELETE FROM sbo_allotment
                WHERE TicketId = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.TicketId#">
                    AND TransactionDate = <cfqueryparam cfsqltype="cf_sql_date" value="#date_#"> 
                    AND Type = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.Type#">
            </cfquery>
            <cfreturn "<b style='color:green;'>Transaction Updated</b>">
        <cfelse>
        	<cfreturn "<b style='color:red;'>No Transaction Was Found</b>">
 		</cfif>       
	</cffunction>
    
    <cffunction name="SaveJobbingBook" access="public" returntype="void">
    	<cfargument name="f" type="struct" required="yes">
        
        <!--- delete initial entry before procedding with cal --->
		
        <!--- 
        <cfquery datasource="#this.dsn#">
        	DELETE FROM sbo_nse_trade 
            WHERE Type = <cfqueryparam value="#arguments.f.AllotmentType#" cfsqltype="cf_sql_varchar">
            AND TicketId = <cfqueryparam value="#arguments.f.TicketId#" cfsqltype="cf_sql_varchar">
        </cfquery> 
		<cfquery datasource="#this.dsn#">
        	DELETE FROM sbo_allotment 
            WHERE Type = <cfqueryparam value="#arguments.f.AllotmentType#" cfsqltype="cf_sql_varchar">
            AND TicketId = <cfqueryparam value="#arguments.f.TicketId#" cfsqltype="cf_sql_varchar">
        </cfquery>
		<cfquery datasource="#this.dsn#">
        	DELETE FROM sbo_client_account 
            WHERE Source = <cfqueryparam value="#arguments.f.TicketId#" cfsqltype="cf_sql_varchar">
        </cfquery> 
        --->
        <!---//--->
        <cfset tdes = "Buy">
        <cfset stemp="">
        <cfset tkid = arguments.f.ticketid & arguments.f.allotmenttype>
        <cfset sboid = trim(ListLast(arguments.f.clientName,'|'))>
        <cfset tprice = arguments.f.unit * arguments.f.price>
        <cfquery datasource="#this.dsn#" name="qC">
        	SELECT CSCSNumber, CSCSAccountId FROM sbo_cscs_account 
            WHERE SBOClientId = <cfqueryparam value="#sboid#" cfsqltype="cf_sql_integer">
        </cfquery>
        <cfquery name="tr" datasource="#this.dsn#">
        	SELECT * FROM sbo_trade_rate
        </cfquery>
        <cfif arguments.f.AllotmentType eq 2><cfset tdes = "Sell"></cfif>
        <cfquery name="qS" datasource="#this.dsn#">
        	SELECT * FROM core_stock WHERE StockId = <cfqueryparam cfsqltype="cf_sql_integer" value="#arguments.f.StockId#">
        </cfquery>
        <cfquery datasource="#this.dsn#">
        	INSERT INTO	sbo_nse_trade	(
            	Type, TypeDescription, TicketId, 
				<cfif arguments.f.AllotmentType eq 1> HomeBrokerCode, AwayBrokerCode <cfelse> AwayBrokerCode, HomeBrokerCode </cfif>,
                Security, Units, UnitPrice, TotalPrice, ClientName, CSCSNumber, TransactionDate, BranchId
            )	
            VALUES	(
            	<cfqueryparam value="#arguments.f.AllotmentType#" cfsqltype="cf_sql_varchar">, <cfqueryparam value="#tdes#" cfsqltype="cf_sql_varchar">,
                <cfqueryparam value="#arguments.f.TicketId#" cfsqltype="cf_sql_varchar">, <cfqueryparam value="#arguments.f.SellingHouse#" cfsqltype="cf_sql_varchar">,
                <cfqueryparam value="#arguments.f.BuyingHouse#" cfsqltype="cf_sql_varchar">, <cfqueryparam value="#qS.Symbol#" cfsqltype="cf_sql_varchar">,
                <cfqueryparam value="#arguments.f.Unit#" cfsqltype="cf_sql_integer">, <cfqueryparam value="#arguments.f.Price#" cfsqltype="cf_sql_double">,
                <cfqueryparam value="#tprice#" cfsqltype="cf_sql_double">, <cfqueryparam value="#ListFirst(arguments.f.clientName,'|')#" cfsqltype="cf_sql_varchar">,
                <cfqueryparam value="#qC.CSCSNumber#" cfsqltype="cf_sql_varchar">, <cfqueryparam value="#arguments.f.TransactionDate#" cfsqltype="cf_sql_date">,0
            )
        </cfquery> 
        <!--- save allotment --->  
             
        <cfquery name="SBOClient" datasource="#this.dsn#">
            SELECT * FROM vw_sbo_client 
            WHERE SBOClientId = <cfqueryparam value="#sboId#" cfsqltype="cf_sql_integer">
        </cfquery> 
             
        <cfset commi_ = tr.Commission> 
		<cfif SBOClient.ChargeCommission >
            <cfif SBOClient.CommissionRate gt tr.Commission> 
                <cfset commi_ = tr.Commission>
            <cfelse>
                <cfset commi_ = SBOClient.CommissionRate>
            </cfif>
        <cfelse>  
            <cfset commi_ = 0> 
        </cfif>  
        <!---<cfif commi_ gt commRate>
            <cfset commi_ = commRate >
        </cfif>
        <cfif commi_ lt 0><cfset commi_ = tr.Commission></cfif>--->
        
        <cfset obj.Nse = 0 >
        <cfset obj.NseVat = 0 >
        <cfset obj.SellCSCS = 0>
        <cfset obj.SellCSCSVat = 0>
        <cfset obj.BuyCSCSVat = 0>
        <cfset obj.Sec = 0 >
        <cfset obj.BuyCSCS = 0 >  
        
        <cfset commiVat_ = (tr.CommissionVat/100) * Commi_ >
        <cfset obj.Commission = (Commi_/100) * tprice >
        
        <!--- check if there is a discount on the account type --->
        <cfif val(SBOClient.DiscountRate) neq 0> 
            <cfset obj.Commission = (abs(1-val(SBOClient.DiscountRate))/100) * obj.Commission >
        </cfif>
        <!--- end check --->  
                        
        <cfset obj.ContractStamp = (tr.ContractStamp/100) * tprice > 
        <cfset obj.CommissionVAT = tprice * (commiVat_/100)>
        <cfset gn = obj.Commission + obj.CommissionVat + obj.ContractStamp >
        <!---TODO---
            some work still need to be done here. 
            i need to calculate AgentInterestRate 
        ---> 
        <cfswitch expression="#arguments.f.AllotmentType#" >
            <cfcase value="1"> 
                <cfset obj.Sec = (tr.Sec/100) * tprice>			<cfset obj.BuyCSCS = (tr.BuyCSCS/100) * tprice >
                <cfset BuyCSCSVAT_ = (tr.BuyCSCSVAT/100) * tr.BuyCSCS>		<cfset obj.BuyCSCSVat = (BuyCSCSVAT_/100) * tprice >
                <cfset obj.BuyCSCSCharges = obj.BuyCSCS + obj.BuyCSCSVat>  	<cfset obj.NetValue = tprice + (gn + obj.Sec + obj.BuyCSCSCharges) > 
            </cfcase> 
            <cfcase value="2"> 
                <cfset obj.Nse = (tr.Nse/100) * tprice>			<cfset obj.NseVat = (tr.NseVat/100) * tprice >
                <cfset obj.NseCharges = obj.Nse + obj.NseVat>				<cfset SellCSCSVAT_ = (tr.SellCSCSVAT/100) * tr.SellCSCS>
                <cfset obj.SellCSCS = (tr.SellCSCS/100) * tprice>	<cfset obj.SellCSCSVat = (SellCSCSVAT_/100) * tprice> 
                <cfset obj.SellCSCSCharges = obj.SellCSCS + obj.SellCSCSVat><cfset obj.NetValue = tprice - (gn + obj.NseCharges + obj.SellCSCSCharges)> 
            </cfcase> 
        </cfswitch>
            
        <cfquery datasource="#this.dsn#">
        	INSERT INTO	sbo_allotment	(
            	Type, TypeDescription, TicketId, StockId, Units, UnitPrice, TotalPrice, CSCSAccountId, TransactionDate,
                SEC, BuyCSCS, BuyCSCSVAT, SellCSCS, SellCSCSVAT, NSE, NSEVAT, ContractStamp, NetValue, Commission, VAT
            )	
            VALUES	(
            	<cfqueryparam value="#arguments.f.AllotmentType#" cfsqltype="cf_sql_integer">, <cfqueryparam value="#tdes#" cfsqltype="cf_sql_varchar">,
                <cfqueryparam value="#arguments.f.TicketId#" cfsqltype="cf_sql_varchar">, <cfqueryparam value="#arguments.f.StockId#" cfsqltype="cf_sql_integer">,
                <cfqueryparam value="#arguments.f.Unit#" cfsqltype="cf_sql_integer">, <cfqueryparam value="#arguments.f.Price#" cfsqltype="cf_sql_double">,
                <cfqueryparam value="#tprice#" cfsqltype="cf_sql_double">, <cfqueryparam value="#qC.CSCSAccountId#" cfsqltype="cf_sql_integer">,
                <cfqueryparam value="#arguments.f.TransactionDate#" cfsqltype="cf_sql_date">, <cfqueryparam value="#obj.SEC#" cfsqltype="cf_sql_double">,
                <cfqueryparam value="#obj.BuyCSCS#" cfsqltype="cf_sql_double">, <cfqueryparam value="#obj.BuyCSCSVAT#" cfsqltype="cf_sql_double">,
                <cfqueryparam value="#obj.SellCSCS#" cfsqltype="cf_sql_double">, <cfqueryparam value="#obj.SellCSCSVAT#" cfsqltype="cf_sql_double">,
                <cfqueryparam value="#obj.NSE#" cfsqltype="cf_sql_double">, <cfqueryparam value="#obj.NSEVAT#" cfsqltype="cf_sql_double">,
                <cfqueryparam value="#obj.ContractStamp#" cfsqltype="cf_sql_double">, <cfqueryparam value="#obj.NetValue#" cfsqltype="cf_sql_double">,
                <cfqueryparam value="#obj.Commission#" cfsqltype="cf_sql_double">, <cfqueryparam value="#obj.CommissionVAT#" cfsqltype="cf_sql_double">
            )
        </cfquery>
        <!--- //---->
        
        <!---- credit/debit account ----->
        <cfset desc = UCASE(tdes) & " " & NumberFormat(arguments.f.Unit,'_,___') & " " & qS.Symbol & " @ " & arguments.f.Price>
        <cfquery datasource="#this.dsn#">
        	INSERT INTO sbo_client_account (
            	SBOClientId, CSCSAccountId, Source, <cfif arguments.f.AllotmentType eq 2>Credit, Debit<cfelse>Debit, Credit</cfif>, 
                TransactionDate, Description
            )
            VALUES	(
            	<cfqueryparam value="#sboid#" cfsqltype="cf_sql_integer">, <cfqueryparam value="#qC.CSCSAccountId#" cfsqltype="cf_sql_integer">,
                <cfqueryparam value="#arguments.f.ticketId#" cfsqltype="cf_sql_varchar">, <cfqueryparam value="#obj.NetValue#" cfsqltype="cf_sql_double">,
                <cfqueryparam value="0" cfsqltype="cf_sql_double">, <cfqueryparam value="#arguments.f.TransactionDate#" cfsqltype="cf_sql_date">,
                <cfqueryparam value="#desc#" cfsqltype="cf_sql_varchar">
           	)
        </cfquery>
        <!---//--->
        
    </cffunction>
    
    <cffunction name="UpdateAccount" access="remote" returntype="void">
    	<cfargument name="transactionDate" type="date" required="yes">
        <cfargument name="dsn" type="string" required="yes"> 
        
        <cfset var stemp = "">
        <cfset Date_ = dateformat(arguments.transactionDate,'dd/mm/yyyy')>
		<cfset date2_ = dateformat(arguments.transactionDate,'mmyydd')>
		<cfset sdate = dateformat(arguments.transactionDate,'yyyy/m/d')>
        
		<cfquery name="qLk" datasource="#arguments.dsn#">
        	SELECT * FROM acc_sb_link
        </cfquery>
        
        <cfquery name="qAllotB" datasource="#arguments.dsn#">
        	SELECT 
            	SUM(BuyCSCS) BuyCSCS, SUM(BuyCSCSVAT) BuyCSCSVAT, SUM(SellCSCS) SellCSCS, SUM(SellCSCSVAT) SellCSCSVAT, 
                (SUM(NSE) + SUM(NSEVAT)) NSECharges, SUM(Commission) Commission, SUM(ContractStamp) ContractStamp, SUM(VAT) VAT, 
                SUM(SEC) SEC, SUM(NetValue) NetValue, SUM(TotalPrice) TotalPrice  
            FROM sbo_allotment
            WHERE TransactionDate = <cfqueryparam value="#arguments.transactionDate#" cfsqltype="cf_sql_date"> AND
            Type = <cfqueryparam value="1" cfsqltype="cf_sql_varchar">
        </cfquery>
        
        <cfquery name="qAllotS" datasource="#arguments.dsn#">
        	SELECT 
            	SUM(BuyCSCS) BuyCSCS, SUM(BuyCSCSVAT) BuyCSCSVAT, SUM(SellCSCS) SellCSCS, SUM(SellCSCSVAT) SellCSCSVAT, 
                (SUM(NSE) + SUM(NSEVAT)) NSECharges, SUM(Commission) Commission, SUM(ContractStamp) ContractStamp, SUM(VAT) VAT, 
                SUM(SEC) SEC, SUM(NetValue) NetValue, SUM(TotalPrice) TotalPrice  
            FROM sbo_allotment
            WHERE TransactionDate = <cfqueryparam value="#arguments.transactionDate#" cfsqltype="cf_sql_date"> AND
            Type = <cfqueryparam value="2" cfsqltype="cf_sql_varchar">
        </cfquery>    
        
        <cfquery name="qpifB"  datasource="#arguments.dsn#"> 
            SELECT 
            	Sum(alt.NetValue) NetValue
            FROM sbo_allotment AS alt
                Inner Join sbo_cscs_account AS ca ON alt.CSCSAccountId = ca.CSCSAccountId
                Inner Join sbo_client AS scl ON ca.SBOClientId = scl.SBOClientId
                Inner Join sbo_account_type AS at ON scl.AccountTypeId = at.AccountTypeId
            WHERE 
            	at.GeneralLedgerId = <cfqueryparam value="#qLk.PIFGLId#" cfsqltype="cf_sql_integer"> AND  
                alt.Type = <cfqueryparam cfsqltype="cf_sql_varchar" value="1"> AND 
                TransactionDate = <cfqueryparam value="#sdate#" cfsqltype="cf_sql_date"> 
        </cfquery>
        
        <cfquery name="qpifS"  datasource="#arguments.dsn#"> 
            SELECT 
            	Sum(alt.NetValue) NetValue
            FROM sbo_allotment AS alt
                Inner Join sbo_cscs_account AS ca ON alt.CSCSAccountId = ca.CSCSAccountId
                Inner Join sbo_client AS scl ON ca.SBOClientId = scl.SBOClientId
                Inner Join sbo_account_type AS at ON scl.AccountTypeId = at.AccountTypeId
            WHERE 
            	at.GeneralLedgerId = <cfqueryparam value="#qLk.PIFGLId#" cfsqltype="cf_sql_integer"> AND  
                alt.Type = <cfqueryparam cfsqltype="cf_sql_varchar" value="2"> AND 
                TransactionDate = <cfqueryparam value="#sdate#" cfsqltype="cf_sql_date"> 
        </cfquery>    
          
<cfset stemp = ListAppend(stemp,'("SUMM-SELL FOR #date_#","0","#abs(val(qAllotS.NetValue)-val(qpifS.NetValue))#","#qLk.OwnClientGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("COMM-SELL FOR #date_#","0","#val(qAllotS.Commission)#","#qLk.BrokerCommissionGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("TOTAL-SELL FOR #date_#","#val(qAllotS.TotalPrice)#","0","#qLk.TradingBankGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("PIF CLIENT-SELL FOR #date_#","0","#val(qpifS.NetValue)#","#qLk.PIFGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("VAT-SELL FOR #date_#","0","#val(qAllotS.VAT)#","#qLk.VATGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("STAMP-SELL FOR #date_#","0","#val(qAllotS.ContractStamp)#","#qLk.ContractStampGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("NSE-SELL FOR #date_#","0","#val(qAllotS.NSECharges)#","#qLk.NSEGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("CSCS-SELL FOR #date_#","0","#val(qAllotS.SellCSCS)+val(qAllotS.SellCSCSVAT)#","#qLk.SellCSCSGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("SEC-SELL FOR #date_#","0","#val(qAllotS.SEC)#","#qLk.SECGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
			 <!------------------------------------>
<cfset stemp = ListAppend(stemp,'("SUMM-BUY FOR #date_#","#val(qAllotB.NetValue)#","0","#qLk.OwnClientGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>   
<cfset stemp = ListAppend(stemp,'("COMM-BUY FOR #date_#","0","#val(qAllotB.Commission)#","#qLk.BrokerCommissionGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("TOTAL-BUY FOR #date_#","0","#abs(val(qAllotB.TotalPrice)-val(qpifB.NetValue))#","#qLk.TradingBankGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("PIF CLIENT-BUY FOR #date_#","0","#val(qpifB.NetValue)#","#qLk.PIFGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("VAT-BUY FOR #date_#","0","#VAL(qAllotB.VAT)#","#qLk.VATGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("STAMP-BUY FOR #date_#","0","#val(qAllotB.ContractStamp)#","#qLk.ContractStampGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("NSE-BUY FOR #date_#","0","#val(qAllotB.NSECharges)#","#qLk.NSEGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("CSCS-BUY FOR #date_#","0","#val(qAllotB.BuyCSCS)+val(qAllotB.BuyCSCSVAT)#","#qLk.BuyCSCSGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
<cfset stemp = ListAppend(stemp,'("SEC-BUY FOR #date_#","0","#val(qAllotB.SEC)#","#qLk.SECGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
       
       
        <cfquery datasource="#arguments.dsn#">
        	DELETE FROM acc_voucher 
            WHERE PostingDate = <cfqueryparam value="#arguments.transactiondate#" cfsqltype="cf_sql_date"> AND
            (RefNumber LIKE <cfqueryparam value="SL%" cfsqltype="cf_sql_varchar"> OR RefNumber LIKE <cfqueryparam value="BY%" cfsqltype="cf_sql_varchar">)
        </cfquery>
        
		<cfset stemp = 'INSERT INTO acc_voucher (Description, Debit, Credit, GeneralLedgerId, PostingDate, ValueDate, RefNumber, Note) 
			VALUES ' & stemp>
        <cfquery datasource="#arguments.dsn#">
        	#stemp#
        </cfquery>
        
        <!---//---->
    </cffunction>
    
</cfcomponent>