<cfcomponent extends="com.adexfe.officemod.connection"> 
	
    <cffunction name="init" access="public" returntype="CSCSAccountCtrl"> 
        <cfargument name="dsn" required="true" type="string" />
        
        <cfset this = super.init(arguments.dsn) />
        <cfquery name="qData" datasource="#this.dsn#" >
        	SELECT CSCSNumber,CSCSAccountId,SBOClientId,AccountId,ClientName FROM vw_sbo_cscsaccount
        </cfquery>
        <cfset this.query = qData />
        
        <cfreturn this />
    </cffunction>
    
    <cffunction access="public" name="getCSCSAccountByNumber" returntype="query">
    	<cfargument name="CSCSAccountNumber" required="yes" />
        <cfargument name="dsn" required="yes" /> 
        
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,0,0)#">
        	SELECT * FROM vw_sbo_cscsaccount WHERE CSCSNumber = '#arguments.CSCSAccountNumber#'
        </cfquery>
        
        <cfreturn qData />
    </cffunction> 


    <cffunction access="remote" name="getCSCSNumberListByAccDesc" returntype="string">
    	<cfargument name="AccountDesc" required="yes" />
        <cfargument name="dsn" required="yes" >  
        
        <cfset id = val(trim(listlast(arguments.AccountDesc,'|')))>
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,2,0)#">
        	SELECT a.CSCSAccountId,a.CSCSNumber,s.AccountName FROM sbo_cscs_account a join sbo_client s on s.SBOClientId=a.SBOClientId 
            WHERE a.SBOClientId = #Id#
        </cfquery> 
        
        <cfreturn ValueList(qData.CSCSNumber) />
    </cffunction> 
    
    <cffunction access="remote" name="getCHNByCSCSNumber" returntype="string">
    	<cfargument name="cscs" required="yes" />
        <cfargument name="dsn" required="yes" >  
         
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,2,0)#">
        	SELECT CSCSNumber,CHN FROM sbo_cscs_account
            WHERE CSCSNumber = "#arguments.cscs#"
        </cfquery> 
        
        <cfreturn qData.CHN />
    </cffunction>
     
    <cffunction access="remote" name="getSboIdByCSCSNumber" returntype="string">
    	<cfargument name="cscs" required="yes" />
        <cfargument name="dsn" required="yes" >  
         
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,2,0)#">
        	SELECT CSCSNumber,SBOClientId FROM sbo_cscs_account
            WHERE CSCSNumber = "#arguments.cscs#"
        </cfquery> 
        
        <cfreturn qData.SBOClientId />
    </cffunction>
   
    <cffunction access="remote" name="getCSCSNumberByAccDesc" returntype="string">
    	<cfargument name="AccountDesc" required="yes" />
        <cfargument name="dsn" required="yes" >  
        
        <cfset id = val(trim(listlast(arguments.AccountDesc,'|')))>
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,20,0)#">
        	SELECT CSCSAccountId,CSCSNumber,AccountName FROM vw_sbo_cscsaccount
            WHERE SBOClientId = #Id#
        </cfquery> 
        
        <cfreturn qData.CSCSNumber />
    </cffunction> 

    <cffunction access="remote" name="getClientAccountIdListByName" returntype="string">
    	<cfargument name="ClientName" required="yes" />
        <cfargument name="dsn" required="yes" >  
        
        <cfset id = val(trim(listlast(arguments.AccountDesc,'|')))>
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,20,0)#">
        	SELECT CSCSAccountId,CSCSNumber,AccountName FROM vw_sbo_cscsaccount
            WHERE SBOClientId = #Id#
        </cfquery> 
        
        <cfreturn qData.CSCSAccountId />
    </cffunction> 

    <cffunction access="remote" name="getCSCSNumberListByName" returntype="array">
    	<cfargument name="ClientName" required="yes" />
        <cfargument name="dsn" required="yes" >  
        
        <cfset id = val(trim(listlast(arguments.ClientName,'|')))>
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,0,0)#">
        	SELECT CSCSAccountId,CSCSNumber,AccountName FROM vw_sbo_cscsaccount
            WHERE SBOClientId =  #id# 
        </cfquery>  
         
        <cfset i=0/>
        <cfset a=ArrayNew(2) />
        <cfloop query="qData">
			<cfset i = 1 + i >
			<cfset a[i][1] = qData.CSCSAccountId />
            <cfset a[i][2] = qData.CSCSNumber />
        </cfloop> 
        <cfreturn a />
    </cffunction> 
    
    <cffunction access="remote" name="CSCSNumberListByName" returntype="array">
    	<cfargument name="ClientName" required="yes" />
        <cfargument name="dsn" required="yes" >  
        
        <cfset id = val(trim(listlast(arguments.ClientName,'|')))>
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,0,0)#">
        	SELECT CSCSAccountId,CSCSNumber,AccountName FROM vw_sbo_cscsaccount
            WHERE SBOClientId =  #id# 
        </cfquery>  
         
        <cfset i=0/>
        <cfset a=ArrayNew(2) />
        <cfloop query="qData">
			<cfset i = 1 + i >
			<!--- <cfset a[i][1] = qData.CSCSAccountId />
            <cfset a[i][2] = qData.CSCSNumber /> --->
			<cfset a[i][1] = qData.CSCSNumber />
            <cfset a[i][2] = qData.CSCSAccountId />
        </cfloop> 
        <cfreturn a />
    </cffunction> 
    
</cfcomponent>