<cfcomponent extends="com.adexfe.officemod.connection" hint="client transactions">
	
    <cffunction name="init" access="public" returntype="ClientAccount">
    	<cfargument name="dsn" required="yes" type="string" />
        
        <cfset this = super.init(arguments.dsn)>
         
        <cfreturn this />
    </cffunction>  
    
    <cffunction access="public" name="listTransaction" returntype="query">
    	<cfargument name="sboId" type="numeric" required="yes">
        <cfargument name="cscs" type="numeric" required="no" default="0">
        <cfargument name="startDate" required="no" default="#Dateformat(now(),'yyyy')#/1/1">  
    	<cfargument name="endDate" required="no" default="#Dateformat(now(),'yyyy/m/d')#" type="date"> 
        
		<!--- alter date for b/f ---> 
         
        <!---<cfset nparam1 = DateAdd('d',0,arguments.startDate) >--->
        <cfset argument.cscs = 0> 
        
		<cfset SQLStatement = application.conn.RunQuery('
        SELECT * FROM vw_sbo_clientaccount WHERE SBOClientId = #arguments.sboId#
        ORDER BY TransactionDate,Source')> 
                
		<!--- generate balance --->
        <cfset qPos = 0 >
        <cfset bal = 0 >
        <cfset arrbal = ArrayNew(1) >
		<!--- this is like an opening bal --->
 
        <cfloop query="SQLStatement">
            <cfset qPos = qPos + 1 />
            <cfset arrayAppend(arrbal,0) />
            <cfset bal = val(Debit)-val(Credit)> 
            <cfif qpos eq 1>
                <cfset arrbal[qPos] = val(arrbal[qPos]) - bal>
            <cfelse>
                <cfset arrbal[qPos] = val(arrbal[qPos-1]) - bal> 
            </cfif>
        </cfloop> 
		<cfset QueryAddColumn(SQLStatement,'Balance','double',arrbal) /> 
		<!---<cfset oldSQLStatement = Duplicate(SQLStatement) />--->
        <!--- fix past rec ---> 
	
        <cfquery name="d" dbtype="query">
            SELECT SUM(Credit) AS sCredit,SUM(Debit) AS sDebit, SUM(Credit) - SUM(Debit) AS dBalance FROM SQLStatement 
            WHERE TransactionDate <= <cfqueryparam value="#DateAdd('d','-1',arguments.startDate)#" cfsqltype="cf_sql_date" />
        </cfquery>  
        
        <cfset i = 0 > 
            
		<cfset QueryAddRow(SQLStatement)>
        <cfset QuerySetCell(SQLStatement,'TransactionDate',arguments.startDate) >
        <cfset QuerySetCell(SQLStatement,'Credit',val(d.sCredit)) >
        <cfset QuerySetCell(SQLStatement,'Debit',val(d.sDebit)) >
        <cfset QuerySetCell(SQLStatement,'Balance',val(d.dBalance) ) >
        <cfset QuerySetCell(SQLStatement,'Description','Balance Brought Forward' ) >
        <cfset QuerySetCell(SQLStatement,'Source','(B/F)' ) >
        
     	<!---<cfset arguments.startDate = dateformat(DateAdd('d',0,arguments.startDate),'yyyy/mm/dd') />--->
     
 
        <cfquery name="SQLStatement" dbtype="query">
            SELECT * 
            FROM SQLStatement
            WHERE TransactionDate BETWEEN
            <cfqueryparam value="#arguments.startDate#" cfsqltype="cf_sql_date" /> AND 
            <cfqueryparam value="#arguments.endDate#" cfsqltype="cf_sql_date" />
            ORDER BY TransactionDate,Source
        </cfquery>
        
        <cfreturn SQLStatement />
    </cffunction> 
    
    <cffunction access="public" name="getBalance" returntype="numeric">
        <cfargument name="sboId" type="numeric" required="yes">
        <cfargument name="startDate" type="date" required="no" default="#dateformat(now(),'yyyy/m/d')#">
        
        <cfset qBal = RunQuery('
                SELECT SUM(Credit) - SUM(Debit) AS result FROM sbo_client_account 
                WHERE  TransactionDate < "#arguments.startDate#" AND SBOClientId = #arguments.sboId#')>
                
        <cfreturn val(qBal.result)>
     </cffunction> 
     
    <cffunction access="remote" name="getStockHoldByCSCS" returntype="numeric">
        <cfargument name="sboId" type="numeric" required="yes">
        <cfargument name="stockId" type="numeric" required="yes">
        <cfargument name="startDate" type="date" required="no" default="#dateformat(now(),'yyyy/m/d')#">
        <!--- initialize the data --->
        <cfset StockOpen = 0 >
        <cfset StockBuy = 0 >
        <cfset StockSell = 0 >
        <cfset qDate =  RunQuery (' select HoldDate as OpenDate from sbo_client_stock  ') >
        
        <cfset qSOpen = RunQuery (' select Units, HoldDate from sbo_client_stock where StockId = #arguments.stockId# AND SBOClientId = #arguments.sboId#  ') >
        <cfif qSOpen.recordCount >
        	<cfset qSBuy = RunQuery('SELECT SUM(Units) AS BUnits FROM sbo_nse_trade 
                WHERE ((TransactionDate > "#qSOpen.HoldDate#") AND (TransactionDate < "#arguments.startDate#")) AND (Type = 1) AND (SBOClientId = #arguments.sboId#) ')>
        	<cfset qSSell = RunQuery('SELECT SUM(Units) AS SUnits FROM sbo_nse_trade 
                WHERE ((TransactionDate > "#qSOpen.HoldDate#") AND (TransactionDate < "#arguments.startDate#")) AND (Type = 2) AND (SBOClientId = #arguments.sboId#) ')>
         	<cfset StockOpen = #qSOpen.Units# >
         	<cfset StockBuy = #qSBuy.BUnits# >
         	<cfset StockSell = #qSSell.SUnits# >              
        <cfelse>
        	<cfset qSBuy = RunQuery('SELECT SUM(Units) AS BUnits FROM sbo_nse_trade 
                WHERE ((TransactionDate > "#qDate.OpenDate#") AND (TransactionDate < "#arguments.startDate#")) AND (Type = 1) AND (SBOClientId = #arguments.sboId#) ')>
        	<cfset qSSell = RunQuery('SELECT SUM(Units) AS SUnits FROM sbo_nse_trade 
                WHERE ((TransactionDate > "#qDate.OpenDate#") AND (TransactionDate < "#arguments.startDate#")) AND (Type = 2) AND (SBOClientId = #arguments.sboId#) ')>
         	<cfset StockOpen = 0  >
         	<cfset StockBuy = #qSBuy.BUnits# >
         	<cfset StockSell = #qSSell.SUnits# >              
        </cfif>        
        <cfset StockOpen = (#StockOpen# + #StockBuy#) - #StockSell# >  
        <cfreturn val(#StockOpen#)>
        
     </cffunction> 
     


    <cffunction access="public" name="getDebit" returntype="numeric">
        <cfargument name="sboId" type="numeric" required="yes">
        <cfargument name="startDate" type="date" required="no" default="#dateformat(now(),'yyyy/m/d')#">
        
        <cfquery name="qDr" datasource="#this.dsn#" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT  SUM(Debit) AS Debit
            FROM sbo_client_account 
            WHERE  TransactionDate < "#arguments.startDate#" AND SBOClientId = #arguments.sboId#
        </cfquery> 
        
        <cfreturn val(qDr.Debit)>
     </cffunction>   

    <cffunction access="public" name="getCredit" returntype="numeric">
        <cfargument name="sboId" type="numeric" required="yes">
        <cfargument name="startDate" type="date" required="no" default="#dateformat(now(),'yyyy/m/d')#">
        
        <cfquery name="qCr" datasource="#this.dsn#" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT  SUM(Credit) AS Credit
            FROM sbo_client_account 
            WHERE  TransactionDate < "#arguments.startDate#" AND SBOClientId = #arguments.sboId#
        </cfquery> 
        
        <cfreturn val(qCr.Credit)>
     </cffunction> 
     
    <cffunction name="getBalanceByCSCS" access="remote" returntype="string">
    	<cfargument name="cscs" required="yes" type="string">
    	<cfargument name="dsn" required="yes"  type="string">
        
        <cfset var bal = "0">
        <cfset arguments.cscs = val(trim(listlast(arguments.cscs,'-')))>
        <cfif arguments.cscs neq 0>
            <cfquery name="qtemp" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,5,0)#">
                SELECT SBOClientId FROM sbo_cscs_account 
                WHERE CSCSAccountId = #arguments.cscs#
            </cfquery>  
            
            <cfset init(arguments.dsn)>
            <cfset sid = val(qtemp.SBOClientId)>
            <cfset bal = "">
            <cfset bal = Numberformat(getBalance(sid),'_,___.__')>
            <!---<cfset bal = getBalance(sid)>--->
        </cfif>
        
     	<cfreturn bal /> 
     </cffunction>
     
     <!--- 
    <cffunction name="getHoldByCSCS" access="remote" returntype="string">
    	<cfargument name="cscs" required="yes" type="string">
    	<cfargument name="dsn" required="yes"  type="string">
        
        <cfset var bal = "0">
        <cfset arguments.cscs = val(trim(listlast(arguments.cscs,'-')))>
        <cfif arguments.cscs neq 0>
            <cfquery name="qtemp" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,5,0)#">
                SELECT SBOClientId FROM sbo_cscs_account 
                WHERE CSCSAccountId = #arguments.cscs#
            </cfquery>  
            
            <cfset init(arguments.dsn)>
            <cfset sid = val(qtemp.SBOClientId)>
            <cfset holdUnits = "">
            <cfset holdUnits = Numberformat(getHold(sid),'_,___.__')>
            <!---<cfset bal = getBalance(sid)>--->
        </cfif>
        
     	<cfreturn holdUnits /> 
     </cffunction>
     --->
     
    <cffunction name="getAccountNameByCSCS" access="remote" returntype="string">
    	<cfargument name="cscs" required="yes" type="string">
    	<cfargument name="dsn" required="yes"  type="string">
        
        <cfset arguments.cscs = val(trim(listlast(arguments.cscs,'-')))>
        <cfquery name="qtemp" datasource="#arguments.dsn#"  cachedwithin="#CreateTimeSpan(1,0,0,0)#">
        	SELECT AccountName 
            FROM vw_sbo_cscsaccount 
            WHERE CSCSAccountId = #arguments.cscs#
        </cfquery> 
     
     	<cfreturn qtemp.AccountName /> 
     </cffunction>
   
    <cffunction name="getAccountNameByCSCSNumber" access="remote" returntype="string">
    	<cfargument name="cscs" required="yes" type="string">
    	<cfargument name="dsn" required="yes"  type="string">
        
        <cfset arguments.cscs = val(trim(listlast(arguments.cscs,'-')))>
        <cfquery name="qtemp" datasource="#arguments.dsn#"  cachedwithin="#CreateTimeSpan(1,0,0,0)#">
        	SELECT AccountName 
            FROM vw_sbo_cscsaccount 
            WHERE CSCSAccountId = #arguments.cscs#
        </cfquery> 
     
     	<cfreturn qtemp.AccountName /> 
     </cffunction>

     
    <cffunction name="getAccountIdByCSCS" access="remote" returntype="string">
    	<cfargument name="cscs" required="yes" type="string">
    	<cfargument name="dsn" required="yes"  type="string">
        
        <cfset arguments.cscs = val(trim(listlast(arguments.cscs,'-')))>
        <cfquery name="qtemp" datasource="#arguments.dsn#"  cachedwithin="#CreateTimeSpan(1,0,0,0)#">
        	SELECT AccountId 
            FROM vw_sbo_cscsaccount 
            WHERE CSCSAccountId = #arguments.cscs#
        </cfquery> 
     
     	<cfreturn qtemp.AccountId /> 
     </cffunction>
     
    <cffunction name="getCSCSNumber" access="remote" returntype="string">
    	<cfargument name="cscs" required="yes" type="string">
    	<cfargument name="dsn" required="yes"  type="string">
        
        <cfset arguments.cscs = val(trim(listlast(arguments.cscs,'-')))>
        <cfquery name="qtemp" datasource="#arguments.dsn#"  cachedwithin="#CreateTimeSpan(1,0,0,0)#">
        	SELECT CSCSNumber 
            FROM vw_sbo_cscsaccount 
            WHERE CSCSAccountId = #arguments.cscs#
        </cfquery> 
     
     	<cfreturn qtemp.CSCSNumber /> 
     </cffunction>
 
     
    <cffunction name="getAccountIdByCSCS2" access="remote" returntype="string">
    	<cfargument name="cscs" required="yes" type="string">
    	<cfargument name="dsn" required="yes"  type="string">
         
        <cfquery name="qtemp" datasource="#arguments.dsn#"  cachedwithin="#CreateTimeSpan(1,0,0,0)#">
        	SELECT AccountId 
            FROM vw_sbo_cscsaccount 
            WHERE CSCSNumber = "#arguments.cscs#"
        </cfquery> 
     
     	<cfreturn qtemp.AccountId /> 
     </cffunction>
     
</cfcomponent>