<cfcomponent extends="com.adexfe.officemod.connection">
	
    <cffunction name="init" access="public" returntype="ClientCtrl">
    	<cfargument name="dsn" required="yes" type="string" />
        
        <cfset this.dsn = arguments.dsn />
        <cfquery name="qData" datasource="#this.dsn#" >
        	SELECT * FROM vw_sbo_client
        </cfquery>
        <cfset this.query = qData />
        
        <cfreturn this />
    </cffunction>
    
    <cffunction name="ajGetCLCode" access="remote" returntype="string">
    	<cfargument name="param1" required="yes" default="0">
        <cfargument name="dsn" required="yes" >
        
        <cfset var temp = "">
		<cfif param1 eq ""><cfset param1 = 0></cfif> 
        <cfset param1 = val(listlast(param1,'-'))>
		<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        	SELECT GLCode FROM vw_sbo_client WHERE SBOClientId = #param1# 
        </cfquery> 
        <cfif qData.GLCode neq "">
        	<cfset temp = qData.GLCode>
        </cfif>
        
        <cfreturn temp>
    </cffunction>
    
    <cffunction name="ajGetAccountType" access="remote" returntype="string">
    	<cfargument name="param1" required="yes">
        <cfargument name="dsn" required="yes" >
        
        <cfset var temp = "">
		<cfif param1 eq ""><cfset param1 = 0></cfif> 
        <cfset param1 = val(listlast(param1,'-'))>
         
		<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        	SELECT AccountType FROM vw_sbo_client WHERE SBOClientId = #param1#
        </cfquery> 
        <cfif qData.AccountType neq "">
        	<cfset temp = qData.AccountType>
        </cfif>
        <cfreturn temp>
    </cffunction>
    
    <cffunction name="ajGetAccountId" access="remote" returntype="string">
    	<cfargument name="param1" required="yes">
        <cfargument name="dsn" required="yes" >
        
        <cfset var temp = "">
		<cfif param1 eq ""><cfset param1 = 0></cfif> 
        <cfset param1 = val(listlast(param1,'-'))>
         
		<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        	SELECT AccountId FROM vw_sbo_client WHERE SBOClientId = #param1#
        </cfquery> 
        <cfif qData.AccountId neq "">
        	<cfset temp = qData.AccountId>
        </cfif>
        <cfreturn temp>
    </cffunction>
    
    <cffunction access="remote" name="getClientByName" returntype="query">
    	<cfargument name="Clientname" required="yes" >
        <cfargument name="dsn" required="yes" /> 
        
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        	SELECT ClientId,SBOClientId,AccountId,Address
            FROM vw_sbo_client 
            WHERE ClientName = '#arguments.Clientname#'
        </cfquery>
        
        <cfreturn qData />
    </cffunction> 
    
    <cffunction access="remote" name="getAccountIdByClientName" returntype="string">
    	<cfargument name="Clientname" required="yes" >
        <cfargument name="dsn" required="yes">
         
        <cfreturn getClientByName(arguments.Clientname,arguments.dsn).AccountId >
    </cffunction>
    
    <cffunction access="remote" name="getAccountIdByAccDesc" returntype="string">
    	<cfargument name="AccDesc" required="yes" >
        <cfargument name="dsn" required="yes">
         
        <cfset id = val(trim(listlast(arguments.AccDesc,'|')))> 
        
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        	SELECT AccountId FROM vw_sbo_client WHERE SBOClientId = #id#
        </cfquery>
        
        <cfreturn qData.AccountId>
    </cffunction> 

    <cffunction access="remote" name="ajGetCommissionRate" returntype="string">
    	<cfargument name="AccDesc" required="yes" >
        <cfargument name="dsn" required="yes">
         
        <cfset id = val(trim(listlast(arguments.AccDesc,'|')))> 
        
		  	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        		SELECT CommissionRate,ChargeCommission FROM sbo_client 
                WHERE SBOClientId = <cfqueryparam value="#id#" cfsqltype= "cf_sql_integer">
        	</cfquery>
        
	  		<cfset c = val(qData.CommissionRate)>
	  		<cfif qData.ChargeCommission eq "false">
				<cfset c = 0>
	 		</cfif>
	   	<cfreturn c>
    
    </cffunction>
    
    <cffunction access="remote" name="getAddressByAccDesc" returntype="string">
    	<cfargument name="AccDesc" required="yes" >
        <cfargument name="dsn" required="yes" />

        <cfset id = val(trim(listlast(arguments.AccDesc,'|')))> 
        
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        	SELECT Address FROM vw_sbo_client WHERE SBOClientId = #id#
        </cfquery>
        
        <cfset addr = ucase(replacenocase(qData.Address,chr(13),'<br/>','all'))>
        
        <cfreturn addr >
    </cffunction> 

    <cffunction access="remote" name="ajGetAddressByAccDesc" returntype="string">
    	<cfargument name="AccDesc" required="yes" >
        <cfargument name="dsn" required="yes" />

        <cfset id = val(trim(listlast(arguments.AccDesc,'|')))> 
        
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        	SELECT Address FROM vw_sbo_client WHERE SBOClientId = #id#
        </cfquery> 
        
        <cfreturn qData.Address >
    </cffunction>
            
    <cffunction access="remote" name="getAddressByClientName" returntype="string">
    	<cfargument name="Clientname" required="yes" >
        <cfargument name="dsn" required="yes" />
         
        <cfset addr = replacenocase(getClientByName(arguments.Clientname,arguments.dsn).Address,chr(13),'<br/>','all')>
        
        <cfreturn addr >
    </cffunction> 
    
    <cffunction access="remote" name="ajGetAddressByClientName" returntype="string">
    	<cfargument name="Clientname" required="yes" >
        <cfargument name="dsn" required="yes" />
         
        <cfreturn getClientByName(arguments.Clientname,arguments.dsn).Address>
    </cffunction>
    
    <cffunction access="remote" name="lookup" returntype="array"> 
        <cfargument name="dsn" required="yes" type="string">
        
    	<cfquery name="qData" datasource="#arguments.dsn#">
        	SELECT SBOClientId,AccountId,ClientName FROM vw_sbo_client 
        </cfquery>
        
        <cfset a[1][1] = 0 />
        <cfset a[1][2] = "Select" />
        <cfset i=1/>
        <cfloop query="qData" >
        	<cfset i=i+1 />
        	<cfset a[i][1] = SBOClientId />
            <cfset a[i][2] = AccountId & " | " & ClientName />
        </cfloop>
        
        <cfreturn a />
    </cffunction> 

    <cffunction access="remote" name="getGLId" returntype="numeric"> 
    	<cfargument name="id" type="any" required="yes" />
        <cfargument name="dsn" required="yes" type="string">
         
    	<cfquery name="qData" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,1,0,0)#">
        	SELECT GeneralLedgerId FROM vw_sbo_client WHERE ClientId = #val(arguments.id)#
        </cfquery>
        
        <cfreturn val(qData.GeneralLedgerId) />
    </cffunction>
    
    <cffunction access="public" name="getClientNames" returntype="string" > 
        <cfargument name="dsn" required="yes" type="string">
        
    	<cfquery name="qData" dbtype="query" cachedwithin="#CreateTimeSpan(0,0,5,0)#">
        	SELECT ClientName FROM vw_sbo_client 
        </cfquery>
        
        <cfreturn valuelist(qdata.ClientName) />
    </cffunction> 

      <cffunction access="remote" name="ajGetClientByAccountName" returntype="any" >  
        <cfargument name="wc" required="yes" type="string">
        <cfargument name="cc" required="yes" type="string">
        
    	<cfquery name="qData" datasource="#cc#" cachedwithin="#CreateTime(0,30,0)#">
			select AccountInfo 
            FROM vw_sbo_client 
            WHERE AccountName LIKE <cfqueryparam cfsqltype="cf_sql_varchar" value="#left(arguments.wc,255)#%"> <!---limit 0,10 --->
        </cfquery>
        <!---</h1>LIKE '#arguments.wc#%' --->
        <cfreturn valuelist(qdata.AccountInfo) />
    </cffunction>     

    <cffunction access="remote" name="ajGetClientByCSCS" returntype="any" >  
        <cfargument name="wc" required="yes" type="string">
        <cfargument name="cc" required="yes" type="string">
        
    	<cfquery name="qData" datasource="#cc#" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT ClientCSCSNumber
            FROM vw_sbo_cscsaccount 
            WHERE ClientName LIKE <cfqueryparam cfsqltype="cf_sql_varchar" value="#left(arguments.wc,255)#%"> <!--- LIMIT 0,30--->
        </cfquery>
        
        <cfreturn valuelist(qdata.ClientCSCSNumber) />
    </cffunction>    
	
    <cffunction access="remote" name="ajPerc" returntype="any" >  
        <cfargument name="a" required="yes" type="numeric"> 
        <cfargument name="b" required="yes" type="string"> 
        <cfargument name="c" required="yes" type="string">
        <cfargument name="at" required="yes" type="numeric" >
        <cfargument name="t" required="yes" type="string">
        
    	<cfset d = Evaluate(arguments.a) * val(arguments.b) * val(arguments.c) > 
        <cfset d = NumberFormat(d,'9,999.99')>
        <cfswitch expression="#arguments.at#">
        	<cfcase value="1"><!--- buy --->
            	<cfswitch expression="#arguments.t#">
                	<cfcase delimiters="," value="scscs,nse">
                    	<cfset d = 0>
                    </cfcase>
                </cfswitch>
            </cfcase>
        	<cfcase value="2"><!--- sell --->
            	<cfswitch expression="#arguments.t#">
                	<cfcase delimiters="," value="bcscs,sec">
                    	<cfset d = 0>
                    </cfcase>
                </cfswitch>
            </cfcase>
        </cfswitch>
        <cfreturn  d/>
    </cffunction>  
    
    <cffunction access="remote" name="ajPercVAT" returntype="any" >  
        <cfargument name="a" required="yes" type="string">
        <cfargument name="a2" required="yes" type="string"> 
        <cfargument name="b" required="yes" type="string"> 
        <cfargument name="c" required="yes" type="string">
        <cfargument name="at" required="yes" type="numeric" >
        <cfargument name="t" required="yes" type="string">

        <cfset d = (val(arguments.a2)/100) * val(arguments.a)>
        <cfset d2 = (val(arguments.a)/100) * (val(arguments.b) * val(arguments.c))>
        <cfset k  = (d/100) * (val(arguments.b) * val(arguments.c)) >
        <cfset d = d2 + k> 
        <cfset d = NumberFormat(d,'9,999.99')>
        <cfswitch expression="#arguments.at#">
        	<cfcase value="1"><!--- buy --->
            	<cfswitch expression="#arguments.t#">
                	<cfcase delimiters="," value="scscs,nse">
                    	<cfset d = 0>
                    </cfcase>
                </cfswitch>
            </cfcase>
        	<cfcase value="2"><!--- sell --->
            	<cfswitch expression="#arguments.t#">
                	<cfcase delimiters="," value="bcscs,sec">
                    	<cfset d = 0>
                    </cfcase>
                </cfswitch>
            </cfcase>
        </cfswitch>
        <cfreturn  d/>
    </cffunction>  
    
    <cffunction name="ajGetCommission" access="remote" returntype="string">
    	<cfargument name="cl" required="no" type="string" default="">
        <cfargument name="u" required="no" type="string" default="">
        <cfargument name="p" required="no" type="string" default="">
        <cfargument name="dsn" required="yes" type="string">
        
        <cfset c = val(arguments.u)*val(arguments.p)>
        <cfset crate = ajGetCommissionRate(arguments.cl,arguments.dsn)>
        
        <cfquery name="qTr" datasource="#arguments.dsn#">
        	SELECT * FROM sbo_trade_rate
        </cfquery>
        <cfset cr = val(crate)>
        <cfif crate eq 0 or crate gt qTr.Commission>
        	<cfset cr = qTr.Commission>
        </cfif>
        <cfset stemp = (val(cr)/100) * c>
        
        <cfreturn NumberFormat(stemp,'9,999.99')>
     </cffunction>

    <cffunction name="ajGetCommissionVAT" access="remote" returntype="string">
    	<cfargument name="cl" required="no" type="string" default="">
        <cfargument name="u" required="no" type="string" default="">
        <cfargument name="p" required="no" type="string" default="">
        <!---<cfargument name="td" required="no" type="string" default=""> --->
        <cfargument name="dsn" required="yes" type="string">
        
        <cfset comm = ajGetCommission(arguments.cl,arguments.u,arguments.p,arguments.dsn)>

        <cfquery name="qTr" datasource="#arguments.dsn#">
        	SELECT * FROM sbo_trade_rate
        </cfquery>
        <!---
    	<cfset vatDate = dateFormat("2014-10-27",'yyyy-mm-dd') >
   		<cfset newVatDate = dateFormat(arguments.td,'yyyy-mm-dd' >
        --->
        <cfset commVat = (qtr.CommissionVat/100) * val(replace(Comm,',','','all')) > 
        <!---
        <cfif (arguments.td GTE vatDate) AND (arguments.td LE newVatDate) >
        	<cfset obj.CommissionVAT = 0 >
      	</cfif>
         --->
        
        <cfreturn NumberFormat(commVat,'9,999.99')>
     </cffunction>
</cfcomponent>