<cfcomponent output="false"  
	extends="com.adexfe.officemod.connection" displayname="Trade Controller">
	
    <cffunction name="init" access="public" returntype="ClientStockCtrl" >
    	<cfargument name="stockLog" required="no" type="string" /> 
        <cfargument name="branchId" required="yes" type="numeric" /> 
        <cfargument name="dsn" required="true" type="string" />
        <cfargument name="holdDate" required="yes" type="date" />
        
        <cfset this = super.init(arguments.dsn)>
        <cfset this.stockLog = arguments.stockLog >
        <cfset this.uuid = createuuid()>
        <cfset this.branchId = arguments.branchId >
        <cfset this.holdDate = arguments.holdDate >
        
        <cfreturn this />
    </cffunction>
    
    <cffunction access="public" name="processLog" returntype="void" >
    
    	<cfset arrLog = readData()> 
       <!---<cfset arrTr = TransposeLog(arrLog) />  --->
        <cfset saveLog(arrLog) />
        
    </cffunction>
    
    <!---TODO---
    <cffunction name="SendContractNote" returntype="void" access="public">
    	<cfargument name="type" default="mail" hint="sms or mail" >
        <cfargument name="tdate" required="yes" hint="transaction date">
        
        
        <cfset var qtemp = RunQuery()> 
    </cffunction>
    --->
    
    <cffunction name="saveLog" access="private" returntype="void" output="yes" >
    	<cfargument name="log" required="yes" type="array" />
         
        <cfset var sql_clstock = "">
        <cfset var sql_nse = "">
        <cfset var nse_id = 0>
        <cfset stCtrl = CreateObject("component","com.adexfe.officemod.controller.stockCtrlBonds").init(this.dsn) />
        <cfset csCtrl = CreateObject("component","com.adexfe.officemod.controller.cscsAccountCtrl").init(this.dsn) /> 

        
        <!---NOTE---
			delete table first
		--->
        <cfset RunQuery('DELETE FROM sbo_client_stock WHERE HoldDate = "#arguments.log[1]['HoldDate']#"')>
        
        <!--- TODO:
			create bulk insert for nse-trade
			make 'ticketid' and 'type' the internal PK
			create a query like alottment table. then gruop it buy Security,CSCSNumber,UnitPrice
			insert the new query into sbo_allotment table.
		--->
        <cfset qNSE = RunQuery('SELECT MAX(StockHoldId) max_id FROM sbo_client_stock')>
        <cfset nse_id = val(qNSE.max_id)>
        <cfloop array="#arguments.log#" index="lg" > 
        	<cfset nse_id = nse_id + 1> 
			<cfset sql_clstock = ListAppend(sql_clstock,'("#lg.BranchId#","#val(lg.CSCSAccountId)#", "#val(lg.StockId)#", "#lg.CSCSNumber#", "#lg.Chn#", "#lg.HoldDate#", "#lg.Units#", "#lg.ClientName#")')>
                 
        </cfloop> 
        
        <!--- execute bulk inset build --->
        
		<cfset sql_clstock_h = '
			INSERT INTO sbo_client_stock	(BranchId,CSCSAccountId,StockId,CSCSNumber,Chn,HoldDate,Units,ClientName)
			VALUES '>
		
        <cftransaction action="begin">
		 <!--- 	<cfset RunQuery(sql_nse_h & sql_nse)> --->
            <cfset RunQuery(sql_clstock_h & sql_clstock)> 
        </cftransaction>
        
    </cffunction>
    
	<cffunction name="dateF" access="private" returntype="date">
		<cfargument name="dtemp" type="string" required="true" />

		<cfreturn left(dtemp,4) & "/" & mid(dtemp,5,2) & "/" & right(dtemp,2) />
	</cffunction>
    
    
    
	<cffunction name="readData" returntype="array" output="false" access="private" >
     
     <cfset stCtrl = CreateObject("component","com.adexfe.officemod.controller.stockCtrlBonds").init(this.dsn) />
        <cfset csCtrl = CreateObject("component","com.adexfe.officemod.controller.cscsAccountCtrl").init(this.dsn) /> 
            
    
        <cfset fStr = createobject('component','com.adexfe.util.bString').init()>
		<cfset atemp = arraynew(1)/>
		<cfloop list="#this.stocklog#" delimiters="#chr(10)##chr(13)#" index="dataline">
			<cfset obj = structNew() />
			<cfset obj.HomeBrokerCode = trim(left(dataline,5)) />
			<cfset obj.CSCSNumber = trim(mid(dataline,6,12)) />
			<cfset obj.ClientName =  fStr.Capitalize(trim(mid(dataline,18,40))) />
			<cfset obj.Chn = trim(mid(dataline,58,15)) />
			<cfset obj.StockSymbol =  trim(mid(dataline,73,11)) />
			<cfset obj.Units = trim(mid(dataline,84,17)) />            
		    <cfset obj.HoldDate = "#this.holdDate#" />           
		    <cfset obj.BranchId = #request.BranchId# />           
			<cfset obj.StockId = stCtrl.getStockBySymbol(obj.StockSymbol).StockId>
         	<cfset sclient = csCtrl.getCSCSAccountByNumber(obj.CSCSNumber, this.dsn)>
            <cfset obj.CSCSAccountId = sclient.CSCSAccountId > 
            <cfset obj.SBOClientId = sclient.SBOClientId >
    		<cfset arrayappend(atemp,obj)>
		</cfloop>
		<cfreturn atemp />
	</cffunction>
    
    <cffunction name="TransposeLog" returntype="array" access="private">
    	<cfargument name="stockLog" required="yes" type="array" />
        
        <cfset arr = arrayNew(1) />
        <cfset stCtrl = CreateObject("component","com.adexfe.officemod.controller.stockCtrlBonds").init(this.dsn) />
        <cfset csCtrl = CreateObject("component","com.adexfe.officemod.controller.cscsAccountCtrl").init(this.dsn) /> 
        <!---NOTE---
			load all clients that have
			commission rate is set for
		--->
        <cfset qSBOClient = RunQuery('SELECT CommissionRate,ChargeCommission,SBOClientId,AgentInterestRate,DiscountRate FROM vw_sbo_client')>
        
		<!--- get settings --->
		<cfset tr = RunQuery('SELECT * FROM sbo_trade_rate')> 
        <cfset trS = RunQuery('SELECT * FROM sbo_trade_setting')>
        
        <cfloop array="#arguments.nseLog#" index="sLog" >
        	<cfset obj = structNew() />
            <cfset obj = sLog />
            <!---NOTE---
				convert [StockSymbol],[sLog.CSCSNumber]
				[sLog.ClientName] to proper database
				format
			--->
            <cfset obj.StockId = stCtrl.getStockBySymbol(sLog.StockSymbol).StockId>
            <cfset sclient = csCtrl.getCSCSAccountByNumber(sLog.CSCSNumber, this.dsn)>
            
        <!--- if sclient is empty and the settings says: can add new client, then add the client --->

 
             <cfset obj.CSCSAccountId = sclient.CSCSAccountId > 
            <cfset obj.SBOClientId = sclient.SBOClientId >
            
            <!---
				check to see if the current user
				has commission rate set in his
				account
			--->

  			<cfset PstockId = 0 >
  			<cfset PStockId = stCtrl.getStockBySymbol(obj.StockSymbol).StockId>
            <cfset qStype = RunQuery('SELECT * from core_stock where StockId = #PStockId# ')>
            <cfset stocktype = '' >
            <cfset StockType = #qStype.Type# >
                  
            
			<!--- PROCESS PRIMARY MARKET DEALS --->
            
            <cfquery name="SBOClient" dbtype="query">
            	SELECT CommissionRate,ChargeCommission,DiscountRate FROM qSBOClient WHERE SBOClientId = #val(obj.SBOClientId)#
            </cfquery> 
            
           <!--- <cfset commRate = tr.CommissionVAT >--->
            <cfset commi_ = tr.Commission>
            <cfif SBOClient.RecordCount>
				<!---<cfset commRate = val(SBOClient.CommissionRate) - tr.CommissionVAT>--->
                <cfif SBOClient.ChargeCommission >
                    <cfif SBOClient.CommissionRate gt tr.Commission> 
                        <cfset commi_ = tr.Commission>
                    <cfelse>
                        <cfset commi_ = SBOClient.CommissionRate>
                    </cfif>
                <cfelse>
                    <!--- use system commission rate --->
                    <!---<cfset obj.Commission =  (tr.Commission/100) * sLog.TotalPrice >--->
                    <cfset commi_ = 0>
                    <!---
                        add skipcommision field in client table
                        if skip commision, then commisionvat = 0 and commision = 0
                    ---> 
                </cfif>
            </cfif>
            <!---<cfif commi_ gt commRate>
            	<cfset commi_ = commRate >
            </cfif>
            <cfif commi_ lt 0><cfset commi_ = tr.Commission></cfif>--->
            <cfset obj.Nse = 0 >
			<cfset obj.NseVat = 0 >
            <cfset obj.SellCSCS = 0>
            <cfset obj.SellCSCSVat = 0>
            <cfset obj.BuyCSCSVat = 0>
            <cfset obj.Sec = 0 >
            <cfset obj.BuyCSCS = 0 >  
            
            <cfset commiVat_ = (tr.CommissionVat/100) * Commi_ >
			<cfset obj.Commission = (Commi_/100) * sLog.TotalPrice >
            
			<!--- check if there is a discount on the account type --->
            <cfif val(SBOClient.DiscountRate) neq 0> 
            	<cfset obj.Commission = (abs(1-val(SBOClient.DiscountRate))/100) * obj.Commission >
            </cfif>
            <!--- end check --->  
                            
			<cfset obj.ContractStamp = (tr.ContractStamp/100) * sLog.TotalPrice > 
            <cfset obj.CommissionVAT = sLog.TotalPrice * (commiVat_/100)>
            <cfset gn = obj.Commission + obj.CommissionVat + obj.ContractStamp >
            <!---TODO---
				some work still need to be done here. 
				i need to calculate AgentInterestRate 
			--->
            <!---NOTE---
				check transaction type
				1 - buy
				2 - sell
			--->
			
			<!--- remove all charges 
				 round up all money value to 2 decimal places 
				 before insert into db --->
            
            <cfswitch expression="#sLog.Type#" >
            	<cfcase value="1">
                	<cfset obj.TypeDescription = "Buy" >
                	<cfif this.dsn eq "gmt" >
                		<cfset Sec = (tr.Sec/100) * sLog.TotalPrice >
                		<cfset obj.Sec = sec + ((tr.buycscsvat/100) * sec )>
                	<cfelse>
                		<cfset obj.Sec = (tr.Sec/100) * sLog.TotalPrice >
                	</cfif>
                    <cfset obj.BuyCSCS = (tr.BuyCSCS/100) * sLog.TotalPrice >
                    <cfset obj.BuyCSCSVat = (tr.BuyCSCSVAT/100) * obj.BuyCSCS >
                    <cfset obj.BuyCSCSCharges = obj.BuyCSCS + obj.BuyCSCSVat >
                    <cfset obj.NetValue = sLog.TotalPrice + (gn + obj.Sec + obj.BuyCSCSCharges) > 
                </cfcase> 
            	<cfcase value="2">
                	<cfset obj.TypeDescription = "Sell" >
                	<cfset obj.Nse = (tr.Nse/100) * sLog.TotalPrice > 
                    <cfset obj.NseVat = (tr.NseVat/100) * obj.Nse >
                    <cfset obj.NseCharges = obj.Nse + obj.NseVat >
                    <cfset obj.SellCSCS = (tr.SellCSCS/100) * sLog.TotalPrice>
                    <cfset obj.SellCSCSVat = (tr.SellCSCSVAT/100) *  obj.SellCSCS > 
                    <cfset obj.BuyCSCS = (tr.BuyCSCS/100) * sLog.TotalPrice >
                    <cfset obj.BuyCSCSVat = (tr.BuyCSCSVAT/100) * obj.BuyCSCS >
                    <cfset obj.SellCSCSCharges = obj.SellCSCS + obj.SellCSCSVat + obj.BuyCSCS + obj.BuyCSCSVat  >
                    <cfset obj.NetValue = sLog.TotalPrice - (gn + obj.NseCharges + obj.SellCSCSCharges) /> 
                </cfcase> 
            </cfswitch>
            
        	<!---TODO---
				* you still need to compare each transaction
				with the mandate, and flag any that does
				not martch as pending.
				* send alert to the account officer
				* send alert to the client involved
			--->
       
	       <!--- END PROCESSING  PRIMARY MARKET DEALS --->

        

        	<cfset obj.Status = "ok">
            
            <!---NOTE---
				log error if [stockid], [clientname]
				[cscsnumber] was not found in db
			--->
            <cfset err = "" />
            <cfif obj.StockId eq "">
            	<cfset err = ListAppend(err,"<li><b>#sLog.StockSymbol#</b> Is New. Please Add to Stock Table, Under System settings.</li>") />
                <cfset obj.Status = "pending">
            </cfif>
            <cfif obj.CSCSAccountId eq "" >
            	<cfset err = ListAppend(err,"<li>CSCS Number <b>#sLog.CSCSNumber#</b> was not found in the Client CSCS Account Table of <b>#sLog.ClientName#</b>. Please check if the Account for <b>#sLog.ClientName#</b> has been created.</li>") />
                <cfset obj.Status = "pending">
            </cfif>
            <cfif obj.SBOClientId eq "" >
            	<cfset err = ListAppend(err,"<li><b>#sLog.ClientName#</b> was not found in the Client Table. Please check if the Account for <b>#sLog.ClientName#</b> has been created.</li>") />
                <cfset obj.Status = "pending">
            </cfif>       
            <cfset obj.ErrorDescription = err />
            <cfset arrayappend(arr,obj) />      
        </cfloop>
        
        <cfreturn arr />
    </cffunction>

    <cffunction name="getAccountId" access="private" returntype="string">
        <cfargument name="brCode" type="string" required="yes">
        <cfargument name="tid" type="string" required="yes">
        
        <cfset var stemp = "">
        <cfset var accid = "">
        <cfswitch expression="#len(tid)#">
            <cfcase value="1"><cfset accid = "0000#tid#"></cfcase>
            <cfcase value="2"><cfset accid = "000#tid#"></cfcase>
            <cfcase value="3"><cfset accid = "00#tid#"></cfcase>
            <cfcase value="4"><cfset accid = "0#tid#"></cfcase> 
            <cfdefaultcase><cfset accid = "#tid#"></cfdefaultcase>
        </cfswitch>
        <cfset stemp = ucase(brCode) & dateformat(now(),'ymmdd') & accid >
        
        <cfreturn  stemp>
    </cffunction>

 
          
</cfcomponent> 