<cfcomponent output="false"  extends="com.adexfe.officemod.connection" displayname="Trade Controller">
	
    <cffunction name="init" access="public" returntype="TradeCtrl" >
    	<cfargument name="nseLog" required="no" type="string" /> 
        <cfargument name="branchId" required="yes" type="numeric" /> 
        <cfargument name="dsn" required="true" type="string" />
        
        <cfset this = super.init(arguments.dsn)>
        <cfset this.nseLog = arguments.nseLog >
        <cfset this.uuid = createuuid()>
        <cfset this.branchId = arguments.branchId >
        
        <cfreturn this />
    </cffunction>
    
    <cffunction access="public" name="processLog" returntype="void" >
    
    	<cfset arrLog = readData()> 
        <cfset arrTr = TransposeLog(arrLog) />
        <cfset saveLog(arrTr) />
        
    </cffunction>
    
    <cffunction name="CreateContratNote" access="remote" output="no" returntype="void" >
    	<cfargument name="tempid" type="uuid" required="yes">
        <cfargument name="date_" type="date" required="yes">
        
      	<cfset var a = "" >
        <cfset GroupAllotment(arguments.tempid,arguments.date_)>
        
		<!--- use update first. incase the transaction note was ran twice --->
<!---        <cfquery name="qAlt" datasource="">
        
        </cfquery>--->
		<cfset qAlt = RunQuery('
			SELECT *,CONCAT(UCASE(TypeDescription)," ",FORMAT(Units,0)," ",StockSymbol, " @ ", UnitPrice) AS Description 
			FROM vw_sbo_allotment_grouped
			WHERE TempId = "#arguments.tempid#"')>
            
        <cfset sql_ = "INSERT INTO sbo_client_account (SBOClientId,CSCSAccountId,Source,Credit,Debit,TransactionDate,Description) VALUES ">
       
       <cfset sou_sql = "">
       <cfloop query="qAlt">
        	<cfif type eq 1><!--- buy --->
        		<cfset amount = "0,#NetValue#">
             <cfelse>
             	<cfset amount = "#NetValue#,0">
             </cfif>
             <cfset a = listappend(a,'(#val(SBOClientId)#,#val(CSCSAccountId)#,"#TicketId#", #amount#, "#dateformat(TransactionDate,'yyyy/m/d')#", "#Description#")')>
             <cfset sou_sql = ListAppend(sou_sql,'Source = "#TicketId#"')>
        </cfloop>
        
        <cfset sql_slink = RunStockBrokingLink(qAlt,date_)>
        <cfset sou_sql = replacenocase(sou_sql,',',' OR ','ALL')>
		<cfset RunQuery('DELETE FROM sbo_client_account WHERE #sou_sql#')> 
        <cfset RunJobbingBook(qAlt)> 
        
        <cftransaction>              
            <cfset RunQuery(sql_ & a)>
            <cfset RunQuery(sql_slink)>
        </cftransaction>
        
        <cfset RunQuery('
			DELETE FROM sbo_allotment_temp 
			WHERE TransactionDate = "#arguments.date_#" AND tempid = "#arguments.tempid#"')>
            
		<!---NOTE---
			send contract note to client as email
		--->
        <!---TODO---
		<cfthread action="run" name="thread_send_contract_note">
			<cfset SendContractNote("mail",qAlt.TransactionDate)>
		</cfthread>
		--->
			
    </cffunction>
    
    <cffunction name="RunJobbingBook" returntype="string" access="private">
    	<cfargument name="qtemp" required="yes" type="query">
        
		<cfset var sql_D = "">
        <cfset var qMJob = RunQuery('SELECT * FROM sbo_jobbing_book WHERE JobPosition = "outstanding" AND Status = "Valid"')>
        <!--- add the units on the allotmnet query based on the cscs and allotment type --->
        <cfquery name="qNAllotment" dbtype="query">
        	SELECT 
            	CSCSAccountId, Type, SUM(Units) Units,
                TransactionDate
            FROM arguments.qtemp 
            GROUP BY CSCSAccountId, Type, TransactionDate
        </cfquery>
        
        
        <!--- check for client that where involve in the transaction by cscs--->
        <cfloop query="qNAllotment" >
        	<cfif Type eq "1"><!---- buy --->
                <cfquery name="qJob" dbtype="query">
                    SELECT * FROM qMjob 
                    WHERE BuyCSCSAccountId = #CSCSAccountId# AND StockId = #arguments.qtemp.StockId# AND TransactionType = 'BUY'
                </cfquery>
            <cfelse> 
                <cfquery name="qJob" dbtype="query">
                    SELECT * FROM qMjob 
                    WHERE SellCSCSAccountId = #CSCSAccountId# AND StockId = #arguments.qtemp.StockId# AND TransactionType = 'SELL'
                </cfquery>
            </cfif>
            
            <cfif qJob.RecordCount><!--- transaction exists --->  
				<cfset td = dateformat(qNAllotment.TransactionDate,'yyyy/m/d')>
                <cfset note_ = "ok">
                <cfset status = "Valid"> 
                <cfset pos = "Outstanding">
                <cfif qJob.Units eq qNAllotment.Units>
                    <cfset pos = "Treated">
                    <cfset status = "Cancel"> 
                <cfelseif qNAllotment.Units lt qJob.Units>
                    <cfset note_ = "less than"> 
                    <cfset pos = "Stay Action">
                <cfelse>  
                	<cfset note_ = "more than"> 
                    <cfset pos = "Stay Action">
                </cfif>
                <cfset RunQuery('
                        UPDATE sbo_jobbing_book SET 
                            JobPosition="#pos#",
                            Status="#status#",
                            TradedUnits=#qNAllotment.Units#,
                            TransactionDate="#td#",
                            Note = "#note_#"
                        WHERE JobbingBookId = #qJob.JobbingBookId#')> 
           	</cfif>
        </cfloop>
        
    </cffunction>
 
    
    <cffunction name="RunStockBrokingLink" returntype="string" access="private">
    	<cfargument name="qAllot" required="yes" type="query">
        <cfargument name="tDate" required="yes" type="date">
         
        <cfset var stemp = "">
        <cfset var date_ = dateformat(arguments.tdate,'dd/mm/yyyy')>
        <cfset var date2_ = dateformat(arguments.tdate,'mmyydd')>
        <cfset var sdate = dateformat(arguments.tdate,'yyyy/m/d')>
        
		<cfset qSBLink = RunQuery('SELECT * FROM acc_sb_link')>
        <!--- sold --->
        <cfquery name="qSell" dbtype="query">
        	SELECT 
            	SUM(BuyCSCS) BuyCSCS, SUM(BuyCSCSVAT) BuyCSCSVAT, SUM(SellCSCS) SellCSCS,
                SUM(SellCSCSVAT) SellCSCSVAT, SUM(NSECharges) NSECharges, SUM(Commission) Commission,
                SUM(ContractStamp) ContractStamp, SUM(VAT) VAT, SUM(SEC) SEC, SUM(NetValue) NetValue,
                SUM(TotalPrice) TotalPrice  
            FROM arguments.qAllot WHERE Type = '2'
        </cfquery>
        <cfquery name="qpif"  datasource="#this.dsn#"> 
            SELECT Sum(alt.NetValue) NetValue
            FROM sbo_allotment AS alt
            Inner Join sbo_cscs_account AS ca ON alt.CSCSAccountId = ca.CSCSAccountId
            Inner Join sbo_client AS scl ON ca.SBOClientId = scl.SBOClientId
            Inner Join sbo_account_type AS at ON scl.AccountTypeId = at.AccountTypeId
            WHERE at.GeneralLedgerId = #qSBLink.PIFGLId# AND alt.Type = '2' AND TransactionDate = "#sdate#" 
        </cfquery>
        <!---<cfset nonpifNetVal = abs(val(qpif.NetValue)-qsell.NetValue)>--->
	<cfset stemp = ListAppend(stemp,'("SUMM-SELL FOR #date_#","0","#abs(val(qsell.NetValue)-val(qpif.NetValue))#","#qSBLink.OwnClientGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("COMM-SELL FOR #date_#","0","#val(qSell.Commission)#","#qSBLink.BrokerCommissionGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("TOTAL-SELL FOR #date_#","#val(qSell.TotalPrice)#","0","#qSBLink.TradingBankGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("PIF CLIENT-SELL FOR #date_#","0","#val(qpif.NetValue)#","#qSBLink.PIFGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("VAT-SELL FOR #date_#","0","#val(qSell.VAT)#","#qSBLink.VATGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("STAMP-SELL FOR #date_#","0","#val(qSell.ContractStamp)#","#qSBLink.ContractStampGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("NSE-SELL FOR #date_#","0","#val(qSell.NSECharges)#","#qSBLink.NSEGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("CSCS-SELL FOR #date_#","0","#val(qSell.SellCSCS)+val(qSell.SellCSCSVAT)#","#qSBLink.SellCSCSGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("SEC-SELL FOR #date_#","0","#val(qSell.SEC)#","#qSBLink.SECGLId#","#sdate#","#sdate#","SL#date2_#","Floor Trade")')>
		
		<!--- buy --->
        <cfquery name="qBuy" dbtype="query">
        	SELECT 
            	SUM(BuyCSCS) BuyCSCS, SUM(BuyCSCSVAT) BuyCSCSVAT, SUM(SellCSCS) SellCSCS,
                SUM(SellCSCSVAT) SellCSCSVAT, SUM(NSECharges) NSECharges, SUM(Commission) Commission,
                SUM(ContractStamp) ContractStamp, SUM(VAT) VAT, SUM(SEC) SEC, SUM(NetValue) NetValue,
                SUM(TotalPrice) TotalPrice  
            FROM arguments.qAllot WHERE Type = '1'
        </cfquery>
        <cfquery name="qpif" datasource="#this.dsn#"> 
            SELECT Sum(alt.NetValue) NetValue
            FROM sbo_allotment AS alt
            Inner Join sbo_cscs_account AS ca ON alt.CSCSAccountId = ca.CSCSAccountId
            Inner Join sbo_client AS scl ON ca.SBOClientId = scl.SBOClientId
            Inner Join sbo_account_type AS at ON scl.AccountTypeId = at.AccountTypeId
            WHERE at.GeneralLedgerId = #qSBLink.PIFGLId# AND alt.Type = '1' AND TransactionDate = "#sdate#" 
        </cfquery>
        <!---<cfset nonpifNetVal = abs(val(qpif.NetValue)-val(qbuy.NetValue))>--->
	<cfset stemp = ListAppend(stemp,'("SUMM-BUY FOR #date_#","#val(qbuy.NetValue)#","0","#qSBLink.OwnClientGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("COMM-BUY FOR #date_#","0","#val(qBuy.Commission)#","#qSBLink.BrokerCommissionGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("TOTAL-BUY FOR #date_#","0","#abs(val(qBuy.TotalPrice)-val(qpif.NetValue))#","#qSBLink.TradingBankGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
    
	<cfset stemp = ListAppend(stemp,'("PIF CLIENT-BUY FOR #date_#","0","#val(qpif.NetValue)#","#qSBLink.PIFGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("VAT-BUY FOR #date_#","0","#VAL(qBuy.VAT)#","#qSBLink.VATGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("STAMP-BUY FOR #date_#","0","#val(qBuy.ContractStamp)#","#qSBLink.ContractStampGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("NSE-BUY FOR #date_#","0","#val(qBuy.NSECharges)#","#qSBLink.NSEGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("CSCS-BUY FOR #date_#","0","#val(qBuy.BuyCSCS)+val(qBuy.BuyCSCSVAT)#","#qSBLink.BuyCSCSGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
    
    <cfset stemp = ListAppend(stemp,'("SEC-BUY FOR #date_#","0","#val(qBuy.SEC)#","#qSBLink.SECGLId#","#sdate#","#sdate#","BY#date2_#","Floor Trade")')>
                
        <cfset RunQuery('DELETE FROM acc_voucher WHERE RefNumber = "SL#date2_#" OR RefNumber = "BY#date2_#"')>
        <cfset stemp = 
			'INSERT INTO acc_voucher (Description, Debit, Credit, GeneralLedgerId, PostingDate, ValueDate, RefNumber, Note) 
			VALUES ' & stemp>
        
        <cfreturn stemp>
    </cffunction>
    
    <!---TODO---
    <cffunction name="SendContractNote" returntype="void" access="public">
    	<cfargument name="type" default="mail" hint="sms or mail" >
        <cfargument name="tdate" required="yes" hint="transaction date">
        
        
        <cfset var qtemp = RunQuery()> 
    </cffunction>
    --->
    
    <cffunction name="saveLog" access="private" returntype="void" output="yes" >
    	<cfargument name="log" required="yes" type="array" />
         
        <cfset var sql_alot = "">
        <cfset var sql_nse = "">
        <cfset var nse_id = 0>
        <!---NOTE---
			delete table first
		--->
        <cfset RunQuery('DELETE FROM sbo_nse_trade WHERE TransactionDate = "#arguments.log[1]['TransactionDate']#"')>
        <cfset RunQuery('DELETE FROM sbo_allotment WHERE TransactionDate = "#arguments.log[1]['TransactionDate']#"')>
        <cfset RunQuery('DELETE FROM sbo_allotment_temp WHERE TransactionDate = "#arguments.log[1]['TransactionDate']#"')>
        
        <!--- TODO:
			create bulk insert for nse-trade
			make 'ticketid' and 'type' the internal PK
			create a query like alottment table. then group it buy Security,CSCSNumber,UnitPrice
			insert the new query into sbo_allotment table.
		--->
        <cfset qNSE = RunQuery('SELECT MAX(NSETradeId) max_id FROM sbo_nse_trade')>
        <cfset nse_id = val(qNSE.max_id)>
        <cfloop array="#arguments.log#" index="lg" > 
        	<cfset nse_id = nse_id + 1> 
           	<cfset sql_nse = ListAppend(sql_nse,'("#nse_id#","#lg.Type#", "#lg.TypeDescription#", "#lg.TicketId#", "#lg.BranchId#", "#lg.HomeBrokerCode#", "#lg.AwayBrokerCode#", "#lg.StockSymbol#", "#lg.Units#", "#lg.UnitPrice#", "#lg.TotalPrice#", "#lg.ClientName#", "#lg.CSCSNumber#", "#lg.TransactionDate#")')> 
 
			<cfset sql_alot = ListAppend(sql_alot,'("#this.uuid#",#nse_id#,"#lg.Type#","#lg.TicketId#", "#val(lg.CSCSAccountId)#", "#val(lg.StockId)#", "#lg.Commission#", "#lg.SEC#", "#lg.BuyCSCS#", "#lg.BuyCSCSVAT#", "#lg.ContractStamp#", "#lg.CommissionVAT#", "#lg.NSE#", "#lg.NSEVAT#","#lg.SellCSCS#","#lg.SellCSCSVAT#", "#lg.NetValue#", "#lg.ErrorDescription#","#lg.Status#","#lg.TransactionDate#")')>
                 
        </cfloop> 
        
        <!--- execute bulk inset build --->
        <cfset sql_nse_h = '
			INSERT INTO sbo_nse_trade	(NSETradeId,Type,TypeDescription,TicketId,BranchId,HomeBrokerCode,AwayBrokerCode,
				Security,Units,UnitPrice,TotalPrice,ClientName,CSCSNumber,TransactionDate )
			VALUES '>
        
        
		<cfset sql_alot_h = '
			INSERT INTO sbo_allotment_temp	(TempId,NSETradeId,Type,TicketId,CSCSAccountId,StockId,Commission,SEC,BuyCSCS,BuyCSCSVAT,
				ContractStamp,VAT,NSE,NSEVAT,SellCSCS,SellCSCSVAT,NetValue,ErrorDescription,Status,TransactionDate)
			VALUES '>
		
        <cftransaction action="begin">
			<cfset RunQuery(sql_nse_h & sql_nse)>
            <cfset RunQuery(sql_alot_h & sql_alot)> 
        </cftransaction>
        
    </cffunction>
    
    <cffunction name="GroupAllotment" access="public" returntype="void">
    	<cfargument name="tempid" required="yes" type="uuid">
    	<cfargument name="date_" required="yes" type="date">
        
        <cfset var sql_alot = "">
		<cfset var sql_alot_h = '
			INSERT INTO sbo_allotment	(Type,TicketId,CSCSAccountId,StockId,Commission,SEC,BuyCSCS,BuyCSCSVAT,
				ContractStamp,VAT,NSE,NSEVAT,SellCSCS,SellCSCSVAT,NetValue,TransactionDate,Units,UnitPrice,TotalPrice,TypeDescription)
			VALUES '>
        
            
        <cfset qTempAllot = RunQuery('SELECT * FROM vw_sbo_allotment_grouped WHERE TempId = "#arguments.tempid#" AND TransactionDate = "#arguments.date_#"')>
                   
        <cfloop query="qTempAllot">
        	<!--- nse = nsevat + nse ... meaning nsecharges --->
            <cfset tdate = DateFormat(TransactionDate,'yyyy/m/d')>
			<cfset sql_alot = ListAppend(sql_alot,'("#Type#","#TicketId#", "#CSCSAccountId#", "#StockId#", "#Commission#", "#SEC#", "#BuyCSCS#", "#BuyCSCSVAT#", "#ContractStamp#", "#VAT#", "#NSE#", "#NSEVAT#", "#SellCSCS#", "#SellCSCSVAT#", "#NetValue#", "#tdate#", #Units#,#UnitPrice#,#TotalPrice#,"#TypeDescription#")')>
            	
        </cfloop>
		 
        <cfset RunQuery(sql_alot_h & sql_alot)> 
        
    </cffunction> 
    
	<cffunction name="dateF" access="private" returntype="date">
		<cfargument name="dtemp" type="string" required="true" />

		<cfreturn left(dtemp,4) & "/" & mid(dtemp,5,2) & "/" & right(dtemp,2) />
	</cffunction>
    
  <!---  Read Trading Data   --->  
	
    <cffunction name="readData" returntype="array" output="false" access="private" >
     	
        <cfset fStr = createobject('component','com.adexfe.util.bString').init()>
		<cfset atemp = arraynew(1)/>
		<cfloop list="#this.Nselog#" delimiters="#chr(10)##chr(13)#" index="dataline">
			<cfset obj = structNew() />
			<cfset obj.HomeBrokerCode = trim(left(dataline,5)) />
			<cfset obj.Type =  trim(mid(dataline,8,2)) />
			<cfset obj.TransactionDate = DateF(mid(dataline,12,8)) />
			<cfset obj.StockSymbol =  trim(mid(dataline,20,11)) />
			<cfset obj.Units = trim(mid(dataline,31,17)) />
			<cfset obj.UnitPrice =  trim(mid(dataline,48,17)) />
			<cfset obj.CSCSNumber = trim(mid(dataline,67,10)) />
			<cfset obj.ClientName =  fStr.Capitalize(trim(mid(dataline,77,40))) />
            <!--- remove " from string --->
            <cfset obj.ClientName =  replacenocase(obj.ClientName,'"',"-",'all') />
			<cfset obj.AwayBrokerCode = trim( mid(dataline,117,5)) />
			<cfset obj.TicketId =  trim(mid(dataline,122,9)) />
			<cfset obj.TotalPrice =trim(right(dataline,24))/>
			<cfset obj.BranchId = this.branchId /> 
			<cfset arrayappend(atemp,obj)>
		</cfloop>
		<cfreturn atemp />
	</cffunction>
    
    <cffunction name="TransposeLog" returntype="array" access="private">
    	<cfargument name="nseLog" required="yes" type="array" />
        
        <cfset arr = arrayNew(1) />
        <cfset stCtrl = CreateObject("component","com.adexfe.officemod.controller.stockCtrl").init(this.dsn) />
        <cfset csCtrl = CreateObject("component","com.adexfe.officemod.controller.cscsAccountCtrl").init(this.dsn) /> 
        <!---NOTE---
			load all clients that have
			commission rate is set for
		--->
        <cfset qSBOClient = RunQuery('
			SELECT CommissionRate,ChargeCommission,SBOClientId,AgentInterestRate,DiscountRate 
			FROM vw_sbo_client')>
            
		<cfset tr = RunQuery('SELECT * FROM sbo_trade_rate')> 
		<cfset trS = RunQuery('SELECT * FROM sbo_trade_setting')> 
        
        <cfloop array="#arguments.nseLog#" index="sLog" >
        	<cfset obj = structNew() />
            <cfset obj = sLog />
            <!---NOTE---
				convert [StockSymbol],[sLog.CSCSNumber]
				[sLog.ClientName] to proper database
				format
			--->
            <cfset obj.StockId = stCtrl.getStockBySymbol(sLog.StockSymbol).StockId >
            <cfset sclient = csCtrl.getCSCSAccountByNumber(sLog.CSCSNumber,this.dsn)>

            <!--- if sclient is empty and the settings says: can add new client, then add the client --->
          
            <cfif sclient.Recordcount eq 0 and trS.AutoCreateClient eq true>
            	<!--- create new client --->
                <cfset sname = ListFirst(sLog.clientName,' ')>
                <cfset oname = ListDeleteAt(sLog.ClientName,1,' ')>
                
                <cftransaction action="begin">
					<!--- create crm client --->
                    <cfquery result="rsClient" datasource="#this.dsn#">
                        INSERT INTO crm_client (Surname, OtherNames, OpenDate, ClientType, sclientname)
                        VALUES	(
                            <cfqueryparam value="#sname#" cfsqltype="cf_sql_varchar">,
                            <cfqueryparam value="#oname#" cfsqltype="cf_sql_varchar">,
                            <cfqueryparam value="#now()#" cfsqltype="cf_sql_date">,
                            <cfqueryparam value="individual" cfsqltype="cf_sql_varchar">,
                            <cfqueryparam value="#sLog.clientName#" cfsqltype="cf_sql_varchar">
                        )
                    </cfquery>
                    
                    <!--- create sbo client --->
                    <cfquery result="rsAccount" datasource="#this.dsn#">
                        INSERT INTO sbo_client (AccountName, ClientId, AccountTypeId, OpenDate, ChargeCommission, CommissionRate)
                        VALUES	(
                            <cfqueryparam value="#sname# #oname#" cfsqltype="cf_sql_varchar">,
                            <cfqueryparam value="#rsClient.GENERATED_KEY#" cfsqltype="cf_sql_integer">,
                            <cfqueryparam value="#trS.AccountTypeId#" cfsqltype="cf_sql_varchar">,
                            <cfqueryparam value="#now()#" cfsqltype="cf_sql_date">,
                            <cfqueryparam value="true" cfsqltype="cf_sql_varchar">,
                            <cfqueryparam value="#tr.Commission#" cfsqltype="cf_sql_varchar">
                        )
                    </cfquery>
                    <!--- create the account id --->
                    <cfquery datasource="#this.dsn#">
                        UPDATE sbo_client SET	
                        	AccountId = <cfqueryparam cfsqltype="cf_sql_varchar" value="#getAccountId(request.branchId,rsAccount.GENERATED_KEY)#">
                        WHERE SBOClientId = <cfqueryparam cfsqltype="cf_sql_integer" value="#rsAccount.GENERATED_KEY#">
                    </cfquery>
                    
                    <!--- create the cscs account --->
                    <cfquery result="rsCSCS" datasource="#this.dsn#">
                    	INSERT INTO sbo_cscs_account	(SBOClientId, CSCSNumber)
                        VALUES	(
                        	<cfqueryparam cfsqltype="cf_sql_integer" value="#rsAccount.GENERATED_KEY#">,
                            <cfqueryparam cfsqltype="cf_sql_varchar" value="#sLog.CSCSNumber#">
                        )
                    </cfquery>
                    
                    <cfset sclient = csCtrl.getCSCSAccountByNumber(sLog.CSCSNumber, this.dsn)>
                </cftransaction>
            </cfif>    
            <!------>
            
			
			<cfset obj.CSCSAccountId = sclient.CSCSAccountId /> 
            <cfset obj.SBOClientId = sclient.SBOClientId />
            
            <!---
				check to see if the current user
				has commission rate set in his
				account
			--->
             
            <cfquery name="SBOClient" dbtype="query">
            	SELECT CommissionRate,ChargeCommission,DiscountRate FROM qSBOClient WHERE SBOClientId = #val(obj.SBOClientId)#
            </cfquery> 
            
           <!--- <cfset commRate = tr.CommissionVAT >--->
            <cfset commi_ = tr.Commission>
            <cfif SBOClient.RecordCount>
				<!---<cfset commRate = val(SBOClient.CommissionRate) - tr.CommissionVAT>--->
                <cfif SBOClient.ChargeCommission >
                    <cfif SBOClient.CommissionRate gt tr.Commission> 
                        <cfset commi_ = tr.Commission>
                    <cfelse>
                        <cfset commi_ = SBOClient.CommissionRate>
                    </cfif>
                <cfelse>
                    <!--- use system commission rate --->
                    <!---<cfset obj.Commission =  (tr.Commission/100) * sLog.TotalPrice >--->
                    <cfset commi_ = 0>
                    <!---
                        add skipcommision field in client table
                        if skip commision, then commisionvat = 0 and commision = 0
                    ---> 
                </cfif>
            </cfif>
            <!---<cfif commi_ gt commRate>
            	<cfset commi_ = commRate >
            </cfif>
            <cfif commi_ lt 0><cfset commi_ = tr.Commission></cfif>--->
            
            <cfset obj.Nse = 0 >
			<cfset obj.NseVat = 0 >
            <cfset obj.SellCSCS = 0>
            <cfset obj.SellCSCSVat = 0>
            <cfset obj.BuyCSCSVat = 0>
            <cfset obj.Sec = 0 >
            <cfset obj.BuyCSCS = 0 >  
            
            
			<cfset obj.Commission = (Commi_/100) * sLog.TotalPrice >
            <cfset obj.CommissionVat = (tr.BuyCSCSVAT/100) * obj.Commission >
            
			<!--- check if there is a discount on the account type --->
            <cfif val(SBOClient.DiscountRate) neq 0> 
            	<cfset obj.Commission = (abs(1-val(SBOClient.DiscountRate))/100) * obj.Commission >
            </cfif>
            <!--- end check --->  
                            
			<cfset obj.ContractStamp = (tr.ContractStamp/100) * sLog.TotalPrice > 
            <cfset obj.Commission = (Commi_/100) * sLog.TotalPrice >
            <cfset obj.CommissionVat = (tr.BuyCSCSVAT/100) * obj.Commission >
            <cfset gn = obj.Commission + obj.CommissionVat + obj.ContractStamp >
            <!---TODO---
				some work still need to be done here. 
				i need to calculate AgentInterestRate 
			--->
            <!---NOTE---
				check transaction type
				1 - buy
				2 - sell
			--->
			
			<!--- remove all charges 
				 round up all money value to 2 decimal places 
				 before insert into db --->
            <cfswitch expression="#sLog.Type#" >
            	<cfcase value="1">
                	<cfset obj.TypeDescription = "Buy" >
                	<cfset obj.Sec = (tr.Sec/100) * sLog.TotalPrice>
                    <cfset obj.SecVat = (tr.BuyCSCSVAT/100) * obj.Sec>
					<cfset obj.Sec = obj.Sec + obj.SecVat >
					<cfset obj.BuyCSCS = (tr.BuyCSCS/100) * sLog.TotalPrice >
                    <cfset obj.BuyCSCSVat = (tr.BuyCSCSVAT/100) * obj.BuyCSCS >
                    <cfset obj.BuyCSCSCharges = obj.BuyCSCS + obj.BuyCSCSVat >
                    <cfset obj.NetValue = sLog.TotalPrice + (gn + obj.Sec + obj.SecVat + obj.BuyCSCSCharges) > 
                </cfcase> 
            	
                <cfcase value="2">
                	<cfset obj.TypeDescription = "Sell" >
                	<cfset obj.Nse = (tr.Nse/100) * sLog.TotalPrice > 
                    <cfset obj.NseVat = (tr.NseVat/100) * obj.Nse >
                    <cfset obj.NseCharges = obj.Nse + obj.NseVat >
                    <cfset obj.BuyCSCS = (tr.BuyCSCS/100) * sLog.TotalPrice > 
                    <cfset obj.BuyCSCSVat = (tr.BuyCSCSVAT/100) * obj.BuyCSCS >
                    <cfset obj.SellCSCS = (tr.SellCSCS/100) * sLog.TotalPrice>
                    <cfset obj.SellCSCSVat = (tr.SellCSCSVAT/100) * obj.SellCSCS > 
                    <cfset obj.SellCSCS = obj.SellCSCS + obj.BuyCSCS >
                    <cfset obj.SellCSCSVat = obj.SellCSCSVat + obj.BuyCSCSVat > 
                    <cfset obj.SellCSCSCharges = obj.SellCSCS + obj.SellCSCSVat  >
                    <cfset obj.BuyCSCS = 0 > 
                    <cfset obj.BuyCSCSVat = 0 >
                    
					<cfset obj.NetValue = sLog.TotalPrice - (gn + obj.NseCharges + obj.SellCSCSCharges ) /> 
                </cfcase> 
            </cfswitch>
            
        	<!---TODO---
				* you still need to compare each transaction
				with the mandate, and flag any that does
				not martch as pending.
				* send alert to the account officer
				* send alert to the client involved
			--->
            
        	<cfset obj.Status = "ok">
            
            <!---NOTE---
				log error if [stockid], [clientname]
				[cscsnumber] was not found in db
			--->
            <cfset err = "" />
            <cfif obj.StockId eq "">
            	<cfset err = ListAppend(err,"<li><b>#sLog.StockSymbol#</b> Is New. Please Add to Stock Table, Under System settings.</li>") />
                <cfset obj.Status = "pending">
            </cfif>
            <cfif obj.CSCSAccountId eq "" >
            	<cfset err = ListAppend(err,"<li>CSCS Number <b>#sLog.CSCSNumber#</b> was not found in the Client CSCS Account Table of <b>#sLog.ClientName#</b>. Please check if the Account for <b>#sLog.ClientName#</b> has been created.</li>") />
                <cfset obj.Status = "pending">
            </cfif>
            <cfif obj.SBOClientId eq "" >
            	<cfset err = ListAppend(err,"<li><b>#sLog.ClientName#</b> was not found in the Client Table. Please check if the Account for <b>#sLog.ClientName#</b> has been created.</li>") />
                <cfset obj.Status = "pending">
            </cfif>       
            <cfset obj.ErrorDescription = err />
            <cfset arrayappend(arr,obj) />      
        </cfloop>
        
        <cfreturn arr />
    </cffunction>
    

    <cffunction name="getAccountId" access="private" returntype="string">
        <cfargument name="brCode" type="string" required="yes">
        <cfargument name="tid" type="string" required="yes">
        
        <cfset var stemp = "">
        <cfset var accid = "">
        <cfswitch expression="#len(tid)#">
            <cfcase value="1"><cfset accid = "0000#tid#"></cfcase>
            <cfcase value="2"><cfset accid = "000#tid#"></cfcase>
            <cfcase value="3"><cfset accid = "00#tid#"></cfcase>
            <cfcase value="4"><cfset accid = "0#tid#"></cfcase> 
            <cfdefaultcase><cfset accid = "#tid#"></cfdefaultcase>
        </cfswitch>
        <cfset stemp = ucase(brCode) & dateformat(now(),'ymmdd') & accid >
        
        <cfreturn  stemp>
    </cffunction>
    
          
</cfcomponent> 