<cfcomponent output="false">
	
	<cffunction name="getUser" output="false" access="remote">
		<cfargument name="ClOrdId" type="string" required="true" />
		
		<cfset var q = "" />
		
		<cfquery name="q" datasource="lambeth">
			SELECT ClOrdId, AccountCSCSNo, SecurityID, Quantity
			FROM newordersingle
			WHERE ClOrdId = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ClOrdId#">
		</cfquery>
		
		<cfreturn q />
	</cffunction>


	<cffunction name="saveUser" output="false" access="remote">
		<cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="AccountCSCSNo" type="string" required="true" />
		<cfargument name="SecurityID" type="string" required="true" />
		<cfargument name="Quantity"  required="true" />
		
		<cfif arguments.ClOrdId EQ "">
			<cfset createUser(argumentCollection = arguments) />
		<cfelse>
			<cfset updateUser(argumentCollection = arguments) />
		</cfif>
	</cffunction>
	
	<cffunction name="createUser" output="false" access="private" returntype="any" hint="">
	   <cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="AccountCSCSNo" type="string" required="true" />
		<cfargument name="SecurityID" type="string" required="true" />
		<cfargument name="Quantity"  required="true" />
		
		<cfquery datasource="lambeth">
		INSERT INTO users (ClOrdId,AccountCSCSNo, SecurityID, Quantity)
		VALUES (<cfqueryparam value="#createUUID()#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.AccountCSCSNo#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.SecurityID#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.Quantity#" cfsqltype="cf_sql_numeric"  >
	</cfquery>
	</cffunction>
	
	<cffunction name="updateUser" output="false" access="private" returntype="any" hint="">
	   <cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="AccountCSCSNo" type="string" required="true" />
		<cfargument name="SecurityID" type="string" required="true" />
		<cfargument name="Quantity" required="true" />
		
		<cfquery datasource="lambeth">
			UPDATE users
			SET 
			AccountCSCSNo = <cfqueryparam value="#arguments.AccountCSCSNo#" cfsqltype="cf_sql_varchar">,
			SecurityID = <cfqueryparam value="#arguments.SecurityID#" cfsqltype="cf_sql_varchar">,
			emailAddress = <cfqueryparam value="#arguments.Quantity#"  cfsqltype="cf_sql_numeric">
			WHERE ClOrdId = <cfqueryparam value="#arguments.ClOrdId#" cfsqltype="cf_sql_varchar">
		</cfquery>
	</cffunction>


	<cffunction name="getAllUsers" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qRead="">

		<cfquery name="qRead" datasource="lambeth">
			SELECT ClOrdId,AccountCSCSNo,SecurityID,emailAddress,phone
			FROM	users
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
			ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
			ORDER BY SecurityID ASC
			</cfif>
		</cfquery>

		<cfreturn queryConvertForGrid(qRead, cfgridpage, cfgridpageSize) />
	</cffunction>

</cfcomponent>