<cfcomponent displayname="Voucher Controller" extends="com.adexfe.officemod.connection">

    <cffunction name="init" returntype="VoucherCtrl" access="remote"> 
        <cfargument name="dsn" required="yes">
        
        <cfset this = super.init(arguments.dsn)>
        
		<cfreturn this>
    </cffunction>
    
    <cffunction name="ajGetVoucherType" returntype="string" access="remote">
    	<cfargument name="param1" type="string" required="yes">
        
        <cfset stemp = "">
        
        <cfswitch expression="#left(param1,2)#">
        	<cfcase value="RN">
            	<cfset stemp = "Receipt">
            </cfcase>
        </cfswitch>
        
        <cfreturn stemp>
    </cffunction>
    
    <cffunction name="PostClientVoucher" returntype="void" access="public">
    	<cfargument name="BranchId" required="yes" type="numeric">
        <cfargument name="TransactionType" required="yes" type="string" hint="cc-credit client,dc-debit client"> >
        <cfargument name="FormP" required="yes" type="struct" hint="Form that contains a voucher entry">
        <cfargument name="VoucherSetting" required="no" type="struct" hint="settings of the voucher">
 
 		<cfif arguments.FormP.GeneralLedgerId eq 0>
        	<cfthrow message="<b>The form you submitted did not contain any GL Code.<br/>
            To Avoid Unbalance Transactions, always remember to Enter a Valid GL Code</b>" errorcode="0129">
        </cfif>
        
        <cfset arguments.FormP.Amount = replace(arguments.FormP.Amount,',','','all')>
        
    	<cfset qCSCS = RunQuery('SELECT CSCSAccountId FROM sbo_cscs_account WHERE SBOClientId = #arguments.FormP.SBOClientId#')>
        <cfset qCL = RunQuery('SELECT GeneralLedgerId FROM vw_sbo_client WHERE SBOClientId = #arguments.FormP.SBOClientId#')>
        
        <!--- credit client account --->
        <cftransaction>
        	
        	<cfswitch expression="#arguments.TransactionType#">
            	<cfcase value="cc">
                
                	<cfif IsDefined('VoucherSetting.IsAutoReceiptNumber') and VoucherSetting.IsAutoReceiptNumber>
						<cfif arguments.FormP.type eq "Receipt">
                            <cfset qRef = RunQuery('SELECT count(distinct(RefNumber)) c FROM acc_voucher WHERE Type = "Receipt"')>
                            <cfset bN = CreateObject('component','com.adexfe.util.bNumber').init()>
                            <cfset arguments.FormP.RefNumber = 'RN' & bN.AutoNumberLeadingZero(qRef.C + 1)>
                            <!--- write a routine to keep check if user has used this rn before --->
                        </cfif>
                    </cfif>
                
                	<cfquery datasource="#application.dsn#">
                        INSERT INTO sbo_client_account	(SBOClientId,TransactionDate,Description,Credit,Source,CSCSAccountId)	
                        VALUES	(#arguments.FormP.SBOClientId#,"#arguments.FormP.PostingDate#","#arguments.FormP.Description#",
                        #arguments.FormP.Amount#,"#arguments.FormP.RefNumber##arguments.FormP.Reference#",#val(qCSCS.CSCSAccountId)#)
                    </cfquery> 

                	<cfquery datasource="#application.dsn#">
                        INSERT INTO acc_voucher	(
                        	Note, RefNumber, Reference, ValueDate,PostingDate,
                            Description,Debit,Type,GeneralLedgerId, BranchId )  
                        VALUES	(
                        	"#arguments.FormP.Note#", "#arguments.FormP.RefNumber#",
                             "#arguments.FormP.Reference#","#arguments.FormP.ValueDate#", 
                            "#arguments.FormP.PostingDate#", "#arguments.FormP.Description#", 
                            #arguments.FormP.Amount#, "#arguments.FormP.type#",#arguments.FormP.GeneralLedgerId#,"#arguments.BranchId#" )
                    </cfquery>
                     
                    <!--- cr client GL --->        
                    <cfset RunQuery('
                        INSERT INTO acc_voucher	(Note,RefNumber,Reference,ValueDate,PostingDate,Description,Credit,Type,GeneralLedgerId,
                            BranchId,SBOClientId)  
                        VALUES	("#arguments.FormP.Note#","#arguments.FormP.RefNumber#","#arguments.FormP.Reference#","#arguments.FormP.ValueDate#",
								"#arguments.FormP.PostingDate#",
                            "#arguments.FormP.Description#",#arguments.FormP.Amount#,"#arguments.FormP.type#",
							#qCL.GeneralLedgerId#,"#arguments.BranchId#",#arguments.FormP.SBOClientId#)')>
				</cfcase>
            	<cfcase value="dc">
                	<cfif IsDefined('VoucherSetting.IsAutoPaymentNumber') and VoucherSetting.IsAutoPaymentNumber>
						<cfif arguments.FormP.type eq "Payment">
                            <cfset qRef = RunQuery('SELECT count(distinct(RefNumber)) c FROM acc_voucher WHERE Type = "Payment"')>
                            <cfset bN = CreateObject('component','com.adexfe.util.bNumber').init()>
                            <cfset arguments.FormP.RefNumber = 'PV' & bN.AutoNumberLeadingZero(qRef.C + 1)>
                            <!--- write a routine to keep check if user has used this rn before --->
                        </cfif>
                    </cfif>
					<cfset RunQuery('
                        INSERT INTO sbo_client_account	(
							SBOClientId, TransactionDate, Description, Debit, Source, CSCSAccountId)	
                        VALUES	(
						#arguments.FormP.SBOClientId#, "#arguments.FormP.PostingDate#", "#arguments.FormP.Description#",
                        #arguments.FormP.Amount#, "#arguments.FormP.RefNumber##arguments.FormP.Reference#",#val(qCSCS.CSCSAccountId)#)')>                    
                    <cfset RunQuery('
                        INSERT INTO acc_voucher	(
							Reference, Note, RefNumber, ValueDate, PostingDate, Description, Credit, Type, 
							GeneralLedgerId, BranchId )  
                        VALUES	(
							"#arguments.FormP.Reference#", "#arguments.FormP.Note#", "#arguments.FormP.RefNumber#", 
							"#arguments.FormP.ValueDate#", "#arguments.FormP.PostingDate#",  
							"#arguments.FormP.Description#", #arguments.FormP.Amount#, "#arguments.FormP.type#", 
							#arguments.FormP.GeneralLedgerId#, "#arguments.BranchId#" )')>
                    <!--- dr client GL --->        
                    <cfset RunQuery('
                        INSERT INTO acc_voucher	 (
							Reference, Note, RefNumber, ValueDate, PostingDate,
							Description,Debit,Type,GeneralLedgerId, BranchId,SBOClientId)  
                        VALUES	(
							"#arguments.FormP.Reference#", "#arguments.FormP.Note#", "#arguments.FormP.RefNumber#", "#arguments.FormP.ValueDate#","#arguments.FormP.PostingDate#",
                            "#arguments.FormP.Description#", #arguments.FormP.Amount#,"#arguments.FormP.type#",#qCL.GeneralLedgerId#,
                            "#arguments.BranchId#",#arguments.FormP.SBOClientId#)')>
				</cfcase>
         	</cfswitch>
         </cftransaction>
         
    </cffunction>
    
    <cffunction name="PostGeneralVoucher" returntype="void" access="public">
    	<cfargument name="BranchId" required="yes" type="numeric"> 
        <cfargument name="RefNumber" required="yes" type="string">
        <cfargument name="Reference" required="no" type="string" default="">
        <cfargument name="PostingDate" required="yes" type="date">
        <cfargument name="ValueDate" required="yes" type="date">
        <cfargument name="Amount" required="yes" type="string">
        <cfargument name="Description" required="yes" type="string"> 
        <cfargument name="DebitGLId" required="yes" type="numeric"> 
        <cfargument name="CreditGLId" required="yes" type="numeric">
        <cfargument name="Type" required="yes" type="string">
        <cfargument name="Remark" required="no" type="string">
         
        <cfswitch expression="#arguments.Type#">
            <cfcase value="journal"><cfset typ = "JV"></cfcase>
            <cfcase value="payment"><cfset typ = "PV"></cfcase>
            <cfcase value="receipt"><cfset typ = "RN"></cfcase>
        </cfswitch>
        
        <cfset arguments.RefNumber = typ & arguments.RefNumber>
        <cfset arguments.Amount = replacenocase(arguments.Amount,',','','all')>
   
        <cftransaction>
        	
            <!--- cr GL ---> 
			<cfset RunQuery('
                INSERT INTO acc_voucher		(
					Reference,Note,RefNumber,ValueDate,PostingDate,
					Description,Credit,Type,GeneralLedgerId,BranchId)  
                VALUES	(
					"#arguments.Reference#", "#arguments.Remark#", "#arguments.RefNumber#","#arguments.ValueDate#",
				"#arguments.PostingDate#", "#arguments.Description#",#arguments.Amount#,"#arguments.type#",
				#arguments.CreditGLId#, "#arguments.branchId#")')>
         
            <!--- dr GL --->        
            <cfset RunQuery('
                INSERT INTO acc_voucher	(
					Reference,Note,RefNumber,ValueDate,PostingDate,Description,Debit,
					Type,GeneralLedgerId,BranchId)  
                VALUES	(
					"#arguments.Reference#", "#arguments.Remark#","#arguments.RefNumber#", 
					"#arguments.ValueDate#", "#arguments.PostingDate#", "#arguments.Description#", 
					#arguments.Amount#,"#arguments.type#", #arguments.DebitGLId#,"#arguments.branchId#")')>
 
  <!---  POSTING TO SUB VOUCHER BACKUP  --->
  
			<cfset RunQuery('
                INSERT INTO acc_voucher_full		(
					Reference,Note,RefNumber,ValueDate,PostingDate,
					Description,Credit,Type,GeneralLedgerId,BranchId)  
                VALUES	(
					"#arguments.Reference#", "#arguments.Remark#", "#arguments.RefNumber#","#arguments.ValueDate#",
				"#arguments.PostingDate#", "#arguments.Description#",#arguments.Amount#,"#arguments.type#",
				#arguments.CreditGLId#, "#arguments.branchId#")')>
         
            <!--- dr GL --->        
            <cfset RunQuery('
                INSERT INTO acc_voucher_full	(
					Reference,Note,RefNumber,ValueDate,PostingDate,Description,Debit,
					Type,GeneralLedgerId,BranchId)  
                VALUES	(
					"#arguments.Reference#", "#arguments.Remark#","#arguments.RefNumber#", 
					"#arguments.ValueDate#", "#arguments.PostingDate#", "#arguments.Description#", 
					#arguments.Amount#,"#arguments.type#", #arguments.DebitGLId#,"#arguments.branchId#")')>

  <!--- END OF SUB VOUCHER BACKUP   --->			 
         </cftransaction>
         
    </cffunction>
    
    <cffunction name="InterClientPost" returntype="void" access="public">
    	<cfargument name="BranchId" required="yes" type="numeric"> 
        <cfargument name="RefNumber" required="yes" type="string">
        <cfargument name="Reference" required="no" type="string" default="">
        <cfargument name="PostingDate" required="yes" type="date">
        <cfargument name="ValueDate" required="yes" type="date">
        <cfargument name="Amount" required="yes" type="string">
        <cfargument name="Description" required="yes" type="string"> 
        <cfargument name="CreditSBOClientId" required="yes" type="numeric">
        <cfargument name="DebitSBOClientId" required="yes" type="numeric"> 
        <cfargument name="Type" required="yes" type="string">
        <cfargument name="Remark" required="no" type="string">  
   		
        <cfset arguments.Amount = replace(arguments.Amount,',','','all')>
   
		<cfset qCR = RunQuery('SELECT GeneralLedgerId FROM vw_sbo_client WHERE SBOClientId = #arguments.CreditSBOClientId#')>
        <cfset qDR = RunQuery('SELECT GeneralLedgerId FROM vw_sbo_client WHERE SBOClientId = #arguments.DebitSBOClientId#')>
        
        <cfset qCSCS_CR = RunQuery('SELECT CSCSAccountId FROM sbo_cscs_account WHERE SBOClientId = #arguments.CreditSBOClientId#')>
        <cfset qCSCS_DR = RunQuery('SELECT CSCSAccountId FROM sbo_cscs_account WHERE SBOClientId = #arguments.DebitSBOClientId#')>   
        
        <cftransaction>
                    
			<cfset RunQuery('
                INSERT INTO sbo_client_account	(SBOClientId,TransactionDate,Description,Credit,Source,CSCSAccountId)	
                VALUES	(#arguments.CreditSBOClientId#,"#arguments.PostingDate#","#arguments.Description#",
                    #arguments.Amount#,"#arguments.RefNumber#-#arguments.Reference#",#val(qCSCS_CR.CSCSAccountId)#)')>
                          
            <!--- cr GL ---> 
			<cfset RunQuery('
                INSERT INTO acc_voucher	(Reference, SBOClientId,Note,RefNumber,ValueDate,PostingDate,Description,Credit,Type,GeneralLedgerId,
                    BranchId)  
                VALUES	("#arguments.Reference#",#arguments.CreditSBOClientId#,"#arguments.Remark#","#arguments.RefNumber#","#arguments.ValueDate#",
				"#arguments.PostingDate#","#arguments.Description#",#arguments.Amount#,"#arguments.type#",#qCR.GeneralLedgerId#,
                    "#arguments.branchId#")')>
  <!---------------------------------------------------------------------------->       
			<cfset RunQuery('
                INSERT INTO sbo_client_account	(SBOClientId,TransactionDate,Description,Debit,Source,CSCSAccountId)	
                VALUES	(#arguments.DebitSBOClientId#,"#arguments.PostingDate#","#arguments.Description#",
                    #arguments.Amount#,"#arguments.RefNumber#-#arguments.Reference#",#val(qCSCS_DR.CSCSAccountId)#)')>
            <!--- dr GL --->        
            <cfset RunQuery('
                INSERT INTO acc_voucher	(Reference,SBOClientId,Note,RefNumber,ValueDate,PostingDate,Description,Debit,Type,GeneralLedgerId,
                    BranchId)  
                VALUES	("#arguments.Reference#",#arguments.DebitSBOClientId#,"#arguments.Remark#","#arguments.RefNumber#","#arguments.ValueDate#",
				"#arguments.PostingDate#","#arguments.Description#",#arguments.Amount#,"#arguments.type#",#qDR.GeneralLedgerId#,
                    "#arguments.branchId#")')>
                    
    <!---  SUB ACCOUNT VOUCHER BACKUP POST   --->
    
    			<cfset RunQuery('
                INSERT INTO acc_voucher_full (Reference, SBOClientId,Note,RefNumber,ValueDate,PostingDate,Description,Credit,Type,GeneralLedgerId,
                    BranchId)  
                VALUES	("#arguments.Reference#",#arguments.CreditSBOClientId#,"#arguments.Remark#","#arguments.RefNumber#","#arguments.ValueDate#",
				"#arguments.PostingDate#","#arguments.Description#",#arguments.Amount#,"#arguments.type#",#qCR.GeneralLedgerId#,
                    "#arguments.branchId#")')>
  <!---------------------------------------------------------------------------->       
            <!--- dr GL --->        
            <cfset RunQuery('
                INSERT INTO acc_voucher_full(Reference,SBOClientId,Note,RefNumber,ValueDate,PostingDate,Description,Debit,Type,GeneralLedgerId,
                    BranchId)  
                VALUES	("#arguments.Reference#",#arguments.DebitSBOClientId#,"#arguments.Remark#","#arguments.RefNumber#","#arguments.ValueDate#",
				"#arguments.PostingDate#","#arguments.Description#",#arguments.Amount#,"#arguments.type#",#qDR.GeneralLedgerId#,
                    "#arguments.branchId#")')>

<!---    END OF SUB ACCOUNT BACKUP POST  --->
                
         </cftransaction>
         
    </cffunction>
    
    <cffunction name="SaveMultipleVoucher" access="public" returntype="void">
    	<cfargument type="struct" name="mvData" required="yes">
        
        <cfset var accountid = 0>
        <cfif arguments.mvData.Account neq ""> 
            <cfset accountid = val(trim(ListLast(arguments.mvData.Account,'|')))> 
        </cfif> 
        <cfset glid = val(arguments.mvData.GeneralLedgerId) >
        <cfif glid eq 0><!--- meaning client is involve --->
        	<cfset qTemp = RunQuery('SELECT GeneralLedgerId FROM vw_sbo_client WHERE SBOClientId = #accountid#')>
            <cfset glid = val(qTemp.GeneralLedgerId)>
        </cfif>
        <cfif glid eq 0>
        	<cfthrow errorcode="2101"  message="Error with GLCode" detail="<ul><li>Please check if the Account Type, Has a GLCode.</li><li>Please select a GL Code</li></ul>" >
            <cfabort>                 
        </cfif>
        <cfset RunQuery('
			INSERT INTO acc_multiple_voucher (
				Stamp,SBOClientId,GeneralLedgerId,Credit,Debit,Description,PostingDate,
				ValueDate,RefNumber,Reference
			) VALUES (
				"#arguments.mvData.Stamp#",#accountid#,#glid#,
				#arguments.mvData.Credit#,#arguments.mvData.Debit#,"#arguments.mvData.Description#",
				"#arguments.mvData.PostingDate#","#arguments.mvData.ValueDate#","#arguments.mvData.VoucherType##arguments.mvData.VoucherNumber#",
				"#arguments.mvData.Reference#"
			)')>
         
    </cffunction>
    
    <cffunction name="UpdateMultipleVoucher" access="public" returntype="void">
    	<cfargument type="struct" name="mvData" required="yes">
        <cfargument type="numeric" name="mvid" required="yes">
        
        <cfset var accountid = 0>
        <cfif arguments.mvData.Account neq "">
			<cfset accountid = val(trim(ListLast(arguments.mvData.Account,'|')))>  
        </cfif>
      
        <cfset RunQuery('
			UPDATE acc_multiple_voucher SET 
				Stamp="#arguments.mvData.Stamp#",SBOClientId=#val(accountid)#,
				GeneralLedgerId=#arguments.mvData.GeneralLedgerId#,
				Credit=#arguments.mvData.Credit#,Debit=#arguments.mvData.Debit#,
				Description="#arguments.mvData.Description#",PostingDate="#arguments.mvData.PostingDate#",
				ValueDate="#arguments.mvData.ValueDate#",RefNumber="#arguments.mvData.VoucherType##arguments.mvData.VoucherNumber#",
				Reference="#arguments.mvData.Reference#"
			WHERE MultipleVoucherId = #arguments.mvid#')>
        
    </cffunction>
    
    <cffunction name="DeleteMultipleVoucher" access="public" returntype="void"> 
        <cfargument type="numeric" name="mvid" required="yes"> 
        
        <cfset RunQuery('
			DELETE FROM acc_multiple_voucher 
			WHERE MultipleVoucherId = #arguments.mvid#')>
        
    </cffunction>
    
    <cffunction name="PostMultipleVoucher" access="remote" returntype="void" > 
        <cfargument type="uuid" name="mvstamp" required="yes"> 
        <cfargument type="string" name="dsn" required="yes">
        
        <cfset var sql_gl = "">
        <cfset var sql_cl = ""> 
        
        <cfquery name="qMV" datasource="#arguments.dsn#">  
        	SELECT * FROM acc_multiple_voucher WHERE Stamp = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.mvstamp#">
		</cfquery>
        
        <cfloop query="qMV">
        	<cfset vDate = dateformat(valuedate,'yyyy/mm/dd')>
            <cfset pDate = dateformat(postingdate,'yyyy/mm/dd')>            
        	<!--- handle cl --->
            <cfif sboclientid neq 0> 
				<cfquery name="qCSCS" datasource="#arguments.dsn#" cachedwithin="#CreateTimeSpan(0,0,10,0)#">
                	SELECT cscsaccountid FROM sbo_cscs_account WHERE Sboclientid=#Sboclientid#
                </cfquery>
            	<!--- post 2 client account --->
            	<cfset sql_cl = listappend(sql_cl,'("#val(qCSCS.cscsaccountid)#","#Sboclientid#","#vdate#",
				"#Description#","#Debit#","#Credit#","#RefNumber#")')>
                <!--- client gl ---> 
				<cfset sql_gl = listappend(sql_gl,'("journal","#GeneralLedgerId#","#SBOClientId#","#Debit#","#Credit#",
                "#Description#","#pdate#","#vdate#","#RefNumber#", "#Reference#")')> 
			<cfelse>
				<!--- handle gl ---> 
                <cfset sql_gl = listappend(sql_gl,'("journal","#GeneralLedgerId#","#SBOClientId#","#Debit#","#Credit#",
                "#Description#","#pdate#","#vdate#","#RefNumber#", "#Reference#")')>
           	</cfif>	 
        </cfloop>
        
        <cfif qMV.RecordCount>
            <cftransaction>
            	<cfif len(sql_gl)>
                    <cfquery datasource="#arguments.dsn#">
                        INSERT INTO acc_voucher 
                        (Type,GeneralLedgerId, SBOClientId,Debit,Credit,Description, PostingDate, ValueDate, RefNumber, Reference)
                        VALUES #sql_gl#
                    </cfquery>
                </cfif>
                <cfif len(sql_cl)>
                    <cfquery datasource="#arguments.dsn#">
                        INSERT INTO sbo_client_account 
                        (cscsaccountid, Sboclientid, TransactionDate, Description, Debit, Credit, Source)
                        VALUES #sql_cl#
                    </cfquery>
                </cfif>
                <cfquery datasource="#arguments.dsn#">
                    DELETE FROM acc_multiple_voucher WHERE Stamp = "#arguments.mvstamp#"
                </cfquery>            
            </cftransaction> 
        </cfif>
    </cffunction>
    
    <cffunction name="IsVoucherExists" returntype="boolean" access="public">
    	<cfargument name="refNum" type="string" required="yes">
        <cfargument name="ref" type="string" required="no" default="">
         
        <cfquery name="qTemp" datasource="#this.dsn#">
			SELECT RefNumber FROM acc_voucher 
            WHERE RefNumber = <cfqueryparam  cfsqltype="cf_sql_varchar" value="#arguments.refNum#">
            AND Reference = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ref#">
        </cfquery>
        
        <cfreturn qTemp.RecordCount>
     </cffunction>
     
    <cffunction name="ajIsVoucherExists" returntype="string" access="remote">
    	<cfargument name="refNum" type="string" required="yes"> 
        <cfargument name="ref" type="string" required="yes" default=""> 
        <cfargument name="dsn" type="string" required="yes">
        <cfargument name="refPrefix" type="string" required="no" default="JV"> 

        <cfswitch expression="#arguments.refPrefix#">
        	<cfcase value="Payment"><cfset arguments.refNum = "PV" & arguments.refNum></cfcase>
            <cfcase value="Journal"><cfset arguments.refNum = "JV" & arguments.refNum></cfcase>
            <cfcase value="Receipt"><cfset arguments.refNum = "RN" & arguments.refNum></cfcase>
            <cfdefaultcase>
				<cfif Not(REFind('RN|JV|PV',ucase(arguments.refNum)))> 
                    <cfset arguments.refNum = arguments.refPrefix & arguments.refNum>
                </cfif> 
            </cfdefaultcase>
        </cfswitch>

        <cfquery name="qTemp" datasource="#arguments.dsn#">
			SELECT 
            	RefNumber, PostingDate, ValueDate 
            FROM acc_voucher 
            WHERE RefNumber = <cfqueryparam  cfsqltype="cf_sql_varchar" value="#arguments.refNum#">
            AND Reference = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ref#">
        </cfquery>
        
        <cfset stemp = "">
        <cfif qTemp.RecordCount>
        	<cfset stemp = "<font color=red>This Voucher is not valid. it was posted on #dateformat(qTemp.PostingDate,'dd/mm/yyyy')#.</font>">
            <cfif qTemp.RefNumber eq "">
            	<cfset stemp = "">
            </cfif>
        </cfif>
        <cfreturn stemp>
     </cffunction>
     
  	<cffunction access="public" name="Analysis" returntype="query">
    	<cfargument name="glId" type="numeric" required="yes">
        <cfargument name="glcode" type="string" required="yes">
        <cfargument name="startDate" required="no" default="#Dateformat(now(),'yyyy')#/1/1">  
    	<cfargument name="endDate" required="no" default="#Dateformat(now(),'yyyy')#/12/31" type="date">
        <cfargument name="ptype" required="no" default="PostingDates" type="string">
        
		
		<!-- determine the finaincial year --->
		
		<cfset newyr = dateformat(arguments.startDate,'yyyy/m/d') />
		<cfset acctyr = dateformat(arguments.startDate,'yyyy') />
		
		<!--- <cfset ystart = DateFormat(DateAdd('d',1,accyr.Start),'yyyy/m/d') /> --->
		
		<cfquery name="accyr" datasource="#this.dsn#">
			SELECT * FROM vw_account_year 
			where AccountYear = #acctyr#
		</cfquery> 

		<cfset begdate = Dateformat(accyr.start,'yyyy/m/d') />
		<cfset newdate = Dateformat(dateAdd('d',-1,arguments.startDate),'yyyy/m/d') />
    	<cfset ndate= dateformat(#accyr.Start#,'yyyy-mm-dd')>
        <cfset yrdate= dateformat(#accyr.LastOpeningBalanceDate#,'yyyy-mm-dd')>
        
    	<!--- bring in opeining balance --->
        
        <cfset bdate = dateformat(accyr.LastOpeningBalanceDate,'yyyy/m/d') />
        
         <cfquery name="qOB" datasource="#this.dsn#" cachedwithin="#CreateTimeSpan(1,0,0,0)#">
        	SELECT * FROM vw_acc_openingbalance
            WHERE GeneralLedgerId = <cfqueryparam value="#arguments.glId#" cfsqltype="cf_sql_integer"> and
            Opdate = <cfqueryparam value="#accyr.LastOpeningBalanceDate#" cfsqltype="cf_sql_date"> 
		</cfquery>
        
        <!---Opdate between "#bdate#" and "#begdate#" --->
        
		<!--- alter date for b/f ---> 
        
        <cfquery name="qVAcc" datasource="#this.dsn#" cachedwithin="#CreateTime(0,30,0)#">
            SELECT 
				Credit, Debit, PostingDate, ValueDate, 
				CONCAT(RefNumber,' ',Reference) RefNumber,
				Description, GeneralLedgerId, GLCode,  VoucherId
			FROM vw_acc_voucher 
            WHERE GeneralLedgerId = <cfqueryparam value="#arguments.glId#" cfsqltype="cf_sql_integer">
            and #arguments.ptype# between <cfqueryparam value="#ndate#" cfsqltype="cf_sql_date"> and  <cfqueryparam value="#arguments.endDate#"> 
            ORDER BY #arguments.ptype#,RefNumber
        </cfquery>   
        
		<!--- generate balance --->
        <cfset qPos = 0 >
        <cfset bal = 0 >
        <cfset OpDiff = 0 >
		<cfset arrbal = ArrayNew(1) >
        
        <cfset gldatestart = Dateformat(accyr.start,'yyyy/m/d') />
		<cfset gldate = Dateformat(dateAdd('d',-1,arguments.startDate),'yyyy/m/d') />

	  <cfquery name="d" dbtype="query">
     SELECT SUM(Credit) AS sCredit,SUM(Debit) AS sDebit, SUM(Credit) - SUM(Debit) AS dBalance FROM qVAcc
WHERE #arguments.ptype# between <cfqueryparam value="#ndate#" cfsqltype="cf_sql_date"> and  <cfqueryparam value="#DateAdd('d','-1',arguments.startDate)#">
            </cfquery> 

	<!--- this is like an opening bal --->
        <cfset chkyr = dateFormat('2013/12/31','yyyy/m/d') >
        <cfset i = 0 > 
        
		<cfset tDebit = val(qOB.Debit) + val(d.sDebit)>
        <cfset tCredit = val(qOB.Credit) + val(d.sCredit)>
		
		<cfif yrdate GTE chkyr AND arguments.glId EQ 77 AND This.dsn EQ "signet" >
			<cfset OpDiff = 0 <!--- 3707491.98 ---> >
			<cfset tDebit = val(qOB.Debit) + val(d.sDebit) + OpDiff   >
			<cfset tCredit = val(qOB.Credit) + val(d.sCredit)>
		<cfelse> 
			<cfset tDebit = val(qOB.Debit) + val(d.sDebit)>
			<cfset tCredit = val(qOB.Credit) + val(d.sCredit)>
		</cfif> 
    
        <cfset tBal = tCredit - tDebit> 
       <!---
 		<cfset QuerySetCell(qVAcc,'PostingDate',arguments.startDate) >
        <cfset QuerySetCell(qVAcc,'ValueDate',arguments.startDate) >
       --->
        
	  <cfset QueryAddRow(qVAcc)>
        <cfset QuerySetCell(qVAcc,'PostingDate','#newdate#') >
        <cfset QuerySetCell(qVAcc,'ValueDate',arguments.startDate) >
        <cfset QuerySetCell(qVAcc,'Credit', tCredit) >
        <cfset QuerySetCell(qVAcc,'Debit', tDebit) >
        
        <cfset QuerySetCell(qVAcc,'Description',' BALANCE BROUGHT FORWARD' ) >
        <cfset QuerySetCell(qVAcc,'RefNumber','B/F' ) >
        <cfset QuerySetCell(qVAcc,'GeneralLedgerId',arguments.glid ) > 
        <cfset QuerySetCell(qVAcc,'GLCode',arguments.glcode ) > 
        
        <cfquery name="qVAcc" dbtype="query">
            SELECT * FROM qVAcc
            WHERE #arguments.ptype# BETWEEN
            <cfqueryparam value="#arguments.startDate#" cfsqltype="cf_sql_date" /> AND 
            <cfqueryparam value="#arguments.endDate#" cfsqltype="cf_sql_date" />
            ORDER BY #arguments.ptype#,Description
        </cfquery>

        <cfloop query="qVAcc">
           
           
            	<cfset qPos = qPos + 1 >
            	<cfset arrayAppend(arrbal,0) />
		
				<cfset dbal = val(Debit)-val(Credit)>

            	<cfif qpos eq 1>
                	<cfset arrbal[qPos] = val(arrbal[qPos]) + dbal   >
            	<cfelse>
                	<cfset arrbal[qPos] = val(arrbal[qPos-1])+ dbal   > 
            	</cfif>
             
        </cfloop>
        
	  <cfset QueryAddColumn(qVAcc,'Balance','double',arrbal) />

        <!---cfquery name="qVAcc" dbtype="query">
            SELECT * FROM qVAcc
            WHERE #arguments.ptype# BETWEEN
            <cfqueryparam value="#arguments.startDate#" cfsqltype="cf_sql_date" /> AND 
            <cfqueryparam value="#arguments.endDate#" cfsqltype="cf_sql_date" />
            ORDER BY #arguments.ptype#,RefNumber
        </cfquery--->
        
        <cfreturn qVAcc>
        
    </cffunction> 

          
</cfcomponent>