<cfcomponent displayname="core" extends="com.adexfe.officemod.connection">

	<cffunction name="init" access="public" returntype="core">
        <cfargument name="dsn" required="true" type="string">
        
        <cfset this = super.init(arguments.dsn)> 
		<cfreturn this >
	</cffunction>
    
    <cffunction name="DaysLeft" returntype="numeric" access="public">
    	
        <cfquery name="qtemp" datasource="#this.dsn#">
        	SELECT * FROM core_licence
        </cfquery>
        
	  <cfset dl =0>
	  <cfif IsDate(qtemp.EndDate)>
        	<cfset dl = DateDiff('d',now(),qtemp.EndDate)>
	  </cfif>
        
        <cfreturn abs(dl)>
    </cffunction>
    
    <cffunction name="IsLicenced" returntype="boolean" access="public">	
    	<cfargument name="cn" required="yes" type="string">
        
        <cfset stemp = false>
        <cfquery datasource="#this.dsn#" name="qL">
        	SELECT * FROM core_licence
        </cfquery>
        
        <cfset s = createobject('component','com.adexfe.util.Security').GenerateLicenceKey(arguments.cn,ql.StartDate,ql.EndDate)>
        <cfif ql.LicenceKey eq s and ql.LicenceKey neq "">
        	<!--- check if the lience is between the date --->
            <cfif now() lt ql.EndDate>
                <cfset stemp = true>
            </cfif>
        </cfif>
    	
        <cfreturn stemp>
    </cffunction>
    
    <cffunction name="getVersion" access="public" returntype="numeric">
        
        <cfset var qTemp = RunQuery('SELECT MAX(Number) VN FROM core_version WHERE Installed = "true"') >
        <cfset ftemp = NumberFormat(val(qTemp.VN),'_.____')>
        
        <cfreturn ftemp >
	</cffunction>
        
    <cffunction name="getSolutions" access="public" returntype="query">
        
        <cfset var qTemp = RunQuery('SELECT * FROM core_solution') >
        
        <cfreturn qTemp>
	</cffunction>
    
    <cffunction name="getModules" access="public" returntype="query">
        
        <cfset var qTemp = RunQuery('SELECT * FROM vw_core_module') >
        
        <cfreturn qTemp>
	</cffunction>
    
    <cffunction name="getPages" access="public" returntype="query">
        
        <cfset var qTemp = RunQuery('SELECT * FROM vw_core_page') >
        
        <cfreturn qTemp>
	</cffunction>
    
    <cffunction name="getStock" access="private" returntype="query">  
         
        <cfquery name="qData" datasource="officemod" >
        	SELECT * FROM core_stock
        </cfquery> 
        
        <cfreturn qData />
    </cffunction>
    
    <cffunction access="public" name="getStockBySymbol" returntype="query">
    	<cfargument name="stocksymbol" required="yes" type="string" />
        
        <cfset gs = getStock()>
    	<cfquery name="qData" dbtype="query">
        	SELECT * FROM gs WHERE Symbol = '#arguments.stocksymbol#'
        </cfquery>
        
        <cfreturn qData />
    </cffunction> 
    
    <cffunction access="public" name="ListStock" returntype="query"> 
        
        <cfset gs = getStock()>
    	<cfquery name="qData" dbtype="query">
        	SELECT * FROM gs
        </cfquery>
        
        <cfreturn qData />
    </cffunction> 
    
</cfcomponent>