<cfcomponent displayname="OfficeMod Access Control" extends="com.adexfe.officemod.connection">
	
    <cffunction name="init" returntype="AccessCtrl" access="remote">
    	<cfargument name="userName"  type="string" />
        <cfargument name="password" type="string" />
        <cfargument name="dsn" required="true" type="string" />
        
        <cfscript>
        	this = super.init(arguments.dsn);        
        	this.username = arguments.userName;
        	this.password = arguments.password;
			this.message = "Wrong Username or Password";
        	this.IsLogin = false;
			this.userInfo = "";
			return this;
        </cfscript> 
    </cffunction>
    
    <cffunction name="Login" returntype="void" access="public" > 
        <cfargument name="userName"  type="string" />
        <cfargument name="password" type="string" />
        <cfargument name="dsn" required="true" type="string" />
        
        <cfscript> 
			// check lock table
			
			// check if user exist
			qUser = RunQuery('
				SELECT *
				FROM vw_core_user
				WHERE Email = "#this.username#"');
			// check for role - permission
			this.IsLogin = false;
			now_ = dateformat(now(),'yyyy/mm/dd') & ' ' & timeformat(now(),'hh:mm:ss');
			if(qUser.RecordCount)	{
				// check if user can login
				loginAtt = qUser.LastLoginAttempt; 
				if (not(isdate(qUser.LastLoginAttempt)))	{loginAtt = now();}
				loginAttDiff = DateDiff('h',now(),loginAtt);
				if((loginAttDiff lt 10) and (not(qUser.IsAccessLocked)))	{				
					qRole = RunQuery('SELECT * FROM vw_core_permission WHERE RoleId = #qUser.RoleId#'); 
					sHashedPwd = HashPassword(qUser.RoleId,this.username,this.password);
					sHashedPwdnew = hash(#this.username# & #this.password# & #this.dsn#,'SHA-512');
					if(qUser.PasswordKey eq sHashedPwd){
						lst = createObject('component','com.adexfe.util.List').init();
						this.userInfo = qUser;
						this.roleinfo.roleid = qRole.RoleId;
						this.roleInfo.Solutions = lst.ListDistinct(ValueList(qRole.SolutionName));
						this.roleInfo.SolutionId = lst.ListDistinct(ValueList(qRole.SolutionId));
						this.roleInfo.Modules = "#ValueList(qRole.MolduleFolderName)#,welcome,access_denied";
						this.roleInfo.ModuleId = "#lst.QueryToList(qRole,'ModuleId')#";
						this.roleInfo.AccessRights = ValueList(qRole.AccessRights,'|');
						this.usid = hash(qUser.UserId & qUser.Email);
						this.IsLogin = true;
						RunQuery('UPDATE core_user SET FailedLoginAttempts = 0,
								LastLoginAttempt = "#now_#" WHERE Email = "#this.username#"');
						// get settings
					}
	
					else if(qUser.PasswordKey eq sHashedPwdNew)	{
						lst = createObject('component','com.adexfe.util.List').init();
						this.userInfo = qUser;
						this.roleinfo.roleid = qRole.RoleId;
						this.roleInfo.Solutions = lst.ListDistinct(ValueList(qRole.SolutionName));
						this.roleInfo.SolutionId = lst.ListDistinct(ValueList(qRole.SolutionId));
						this.roleInfo.Modules = "#ValueList(qRole.MolduleFolderName)#,welcome,access_denied";
						this.roleInfo.ModuleId = "#lst.QueryToList(qRole,'ModuleId')#";
						this.roleInfo.AccessRights = ValueList(qRole.AccessRights,'|');
						this.usid = hash(qUser.UserId & qUser.Email & this.dsn,'SHA-512');
						this.IsLogin = true;
						RunQuery('UPDATE core_user SET FailedLoginAttempts = 0,
								LastLoginAttempt = "#now_#" WHERE Email = "#this.username#"');
						// get settings
					}
	
					// start counting fail attempts 
					else	{
						if(qUser.FailedLoginAttempts gt 10)	{
							RunQuery('UPDATE core_user SET IsAccessLocked = "true",
								LastLoginAttempt = "#now_#" WHERE Email = "#this.username#"');					
						}
				else	{
							RunQuery('UPDATE core_user SET FailedLoginAttempts = FailedLoginAttempts + 1,
								LastLoginAttempt ="#now_#" WHERE Email = "#this.username#"');
						}
					}
				}
				else	{
					RunQuery('UPDATE core_user SET IsAccessLocked = "false",
						LastLoginAttempt = "#now_#" WHERE Email = "#this.username#"');
				}
			}
			else {
				qHost = RunQuery('
					SELECT *, 
						HostId AS UserId,
						"home_sprites.png" AS CompanyLogo,
						0 AS BranchId, "" AS CompanyName,
						"" AS LetterHead, "" AS MemberCode, 15 AS PageNumber
					FROM core_host');
				if(Hash('#this.username##this.password#','SHA-512') == qHost.PasswordKey)	{
					this.IsLogin = true;
					this.roleinfo.RoleId = "-1";
					this.roleInfo.Solutions = "*";
					this.roleInfo.SolutionId = -1;
					this.roleInfo.Modules = "*";
					this.roleInfo.ModuleId = -1;
					this.roleInfo.AccessRights = "*";
					this.userInfo = qHost;
					this.usid = hash(1 & qUser.Email);
				}
			}
		</cfscript> 
    </cffunction>
    
    <cffunction name="HashPassword" access="public" returntype="string">
    	<cfargument name="RoleId" type="numeric" required="yes" />
        <cfargument name="Email" type="string" default="#this.username#" />
        <cfargument name="Password" type="string" default="#this.password#" />
        
        <cfset var sHash = "" />
		<cfset qRole = RunQuery('SELECT * FROM vw_core_permission WHERE RoleId = #arguments.RoleId#') />
        <cfset permissionData = ValueList(qRole.SolutionId) & ValueList(qRole.ModuleId) & ValueList(qRole.AccessRights) />
        <cfset sHash = Hash(arguments.Email & arguments.Password & #permissionData#,'SHA-512') />
        
        <cfreturn sHash />
    </cffunction>

     <cffunction name="Logrec" returntype="void" access="public" > 
        <cfargument name="userName"  type="string" />
        <cfargument name="password" type="string" />
        <cfargument name="dsn" required="true" type="string" />
            
        <cfset var sRc = "" />
		<cfset qRole = RunQuery('SELECT * FROM vw_core_permission WHERE RoleId = #arguments.RoleId#') />
        <cfset permissionData = ValueList(qRole.SolutionId) & ValueList(qRole.ModuleId) & ValueList(qRole.AccessRights) />
        <cfset sHash = Hash(arguments.Email & arguments.Password & #arguments.dsn#,'SHA-512') />
        
        <cfreturn sRc />
		
    </cffunction>
    
</cfcomponent>