<cfcomponent displayname="USer Controller" extends="com.adexfe.officemod.connection">
	
    <cffunction name="init" returntype="UserCtrl" access="public">
    	<cfargument name="Email" type="string" /> 
        <cfargument name="RoleId" type="numeric" /> 
        <cfargument name="UserId" type="numeric" default="0" /> 
        <cfargument name="dsn" type="string"  required="yes"/> 
        
        <cfscript>
        	this = super.init(arguments.dsn); 
			this.UserId = arguments.UserId;       
        	this.Email = arguments.Email;  
			this.RoleId = arguments.RoleId; 
			return this;
        </cfscript> 
    </cffunction>
    
    <cffunction name="CreatePassword" returntype="struct" access="public" > 
        
        <cfscript> 
			// generate password
			rand_ = createObject('component','com.adexfe.util.Random').init();
			pwd = rand_.RandValue(); 
			// create hashkey for password
			accCtrl = createObject('component','com.adexfe.officemod.security.AccessCtrl').init('','',this.dsn);
			hashedPwd = accCtrl.HashPassword(this.RoleId,this.Email,pwd);
			pwdStrcut.Password = pwd;
			pwdStrcut.PasswordKey = hashedPwd;
			return pwdStrcut;
		</cfscript>
      
    </cffunction>

    
    <cffunction name="savePassword" returntype="void" access="public" >
        <cfargument name="Pwd" type="struct" required="yes" />
        <cfargument name="UserId" type="numeric" default="#this.userId#" /> 
        
        <cfset RunQuery('
			UPDATE core_user SET 
				PasswordKey = "#Pwd.PasswordKey#"
			WHERE UserId = #arguments.UserId#
		') />
        
    	<cfset sendPassword(Pwd.Password)>
        
    </cffunction>

    <cffunction name="sendPassword" returntype="void" access="public" >
        <cfargument name="Pwd" type="string" required="yes" />
        <cfargument name="subject" type="string" default="officemod Password"/>
        
        <cfmail from="support@oxygenbdc.com" to="#this.email#" subject="#subject#" type="html">
Hello,<br>
Here is your officemod access Information<br>
===================================<br>
username: #this.Email#<br />
Password: #arguments.Pwd#<br/>
===================================<br/>
Please keep your password safe<br><br><br>
Thank you<br>
officemod Team.
    	</cfmail>
      
    </cffunction>
    
</cfcomponent>