<cfcomponent >
	
    <cffunction name="init" access="public" returntype="nsequote"> 
    	<cfargument name="dsn" required="true" type="string" default="officemod" />
        
        <cfset this = init(arguments.dsn) /> 
        
        <cfreturn this /> 
     </cffunction>
	<!--- 
    <cffunction access="public" name="init" returntype="nsequote">
   		<cfargument name="dsn" required="yes" type="string" />
        
        <cfset this = super.init(arguments.dsn)>
         
        <cfreturn this>
    </cffunction>
    
    --->
    
	<cffunction name="getSector" access="remote" returntype="query"> 
        
        <cfquery datasource="#application.dsn#" name="qtemp_" cachedwithin="#CreateTime(0,30,0)#" >
        	SELECT * FROM core_sector ORDER BY Name
        </cfquery>
        
		<cfreturn qtemp_>
	</cffunction>
    
	<cffunction name="getCurrentDate" access="remote" returntype="date"> 
        
        <cfquery datasource="#application.dsn#" name="qtemp" cachedwithin="#CreateTime(0,5,0)#">
        	SELECT MAX(CurrentDate) cd FROM vw_core_stockmarket
        </cfquery>
        
		<cfreturn qtemp.cd>
	</cffunction>
    
	<cffunction name="getPriceList" access="remote" returntype="query">
		<cfargument name="cdate" type="date" required="yes" > 
        
        <cfquery datasource="#application.dsn#" name="qtemp_" cachedwithin="#CreateTime(0,30,0)#" >
        	SELECT * FROM vw_core_stockmarket
            WHERE CurrentDate="#DateFormat(arguments.cdate,'yyyy/mm/dd')#"
            ORDER BY Symbol
        </cfquery>
        
		<cfreturn qtemp_>
	</cffunction>
 
 	<cffunction name="getGroupPriceList" access="remote" returntype="query">
		<cfargument name="cdate" type="date" required="no" default="#getCurrentDate()#"> 
        
        <cfquery datasource="#application.dsn#" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT 
                SUM(ClosePrice) ClosePrice, SUM(OpenPrice) OpenPrice, SectorId, SectorName, StockId, Symbol
            FROM vw_core_stockmarket
            WHERE CurrentDate="#DateFormat(getCurrentDate(),'yyyy/mm/dd')#"
            GROUP BY SectorId 
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>
       
	<cffunction name="getTopGainers" access="remote" returntype="query"> 
        
        <cfset pl = getPriceList(getCurrentDate())>
        <cfquery dbtype="query" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT * FROM pl WHERE change > 0 ORDER BY Change DESC
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>
    
	<cffunction name="getTopLosers" access="remote" returntype="query"> 
        
        <cfset pl = getPriceList(getCurrentDate())>
        <cfquery dbtype="query" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT * FROM pl WHERE change < 0 ORDER BY Change ASC
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>
    
	<cffunction name="getTopDeals" access="remote" returntype="query"> 
        
        <cfset pl = getPriceList(getCurrentDate())>
        <cfquery dbtype="query" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT * FROM pl ORDER BY Trades DESC
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>
    
	<cffunction name="getTopValue" access="remote" returntype="query"> 
        
        <cfset pl = getPriceList(getCurrentDate())>
        <cfquery dbtype="query" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT * FROM pl ORDER BY Value DESC
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>
    
	<cffunction name="getTopVolume" access="remote" returntype="query"> 
        
        <cfset pl = getPriceList(getCurrentDate())>
        <cfquery dbtype="query" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT * FROM pl ORDER BY Volume DESC
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>

	<cffunction name="getTopSectorByPrice" access="remote" returntype="query"> 
        
        <cfset pl = getGroupPriceList(getCurrentDate())>
        <cfquery dbtype="query" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT * FROM pl  
            ORDER BY ClosePrice DESC
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>
    
	<cffunction name="getTopSectorByVolume" access="remote" returntype="query"> 
        
        <cfset pl = getGroupPriceList(getCurrentDate())>
        <cfquery dbtype="query" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT * FROM pl  
            ORDER BY Volume DESC
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>
    
	<cffunction name="getTopSectorByValue" access="remote" returntype="query"> 
        
        <cfset pl = getGroupPriceList(getCurrentDate())>
        <cfquery dbtype="query" name="qtemp" cachedwithin="#CreateTime(0,30,0)#">
        	SELECT * FROM pl  
            ORDER BY Value DESC
        </cfquery>
        
		<cfreturn qtemp>
	</cffunction>
    
</cfcomponent>