<cfcomponent>

	<cffunction name="init" access="public" returntype="Table">
		<cfargument name="GridAttr" type="struct" required="yes">
        <cfargument name="GridAssoAttr" type="array" required="yes">
        <cfargument name="CurrentPage" type="numeric" default="0">

		<cfset this.GridAttr = arguments.GridAttr>
        <cfset this.GridAssoAttr = arguments.GridAssoAttr>
        <cfset this.CurrentPage = arguments.CurrentPage>
        
		<cfreturn this>
	</cffunction>
    
    <cffunction name="BuildHeader" access="public" returntype="string">
    
    	<cfset var stemp = '<table width="100%" border="0" cellspacing="0" cellpadding="0"><thead><tr>'>
         
		<cfloop array="#this.GridAssoAttr#" index="tagInfo">
        	<cfswitch expression="#tagInfo.TagName#">
            	<cfcase value="Column"> 
            		<cfset stemp = stemp & '<td>#GetHeader(tagInfo)#</td>'>
            	</cfcase>
                <cfcase value="Command">
                	<cfset stemp = stemp & '<td>&nbsp;</td>'>
                </cfcase>
            </cfswitch>
        </cfloop>
        
        <cfset stemp = stemp & '</tr></thead>'>
        
    	<cfreturn stemp>    	
    </cffunction>
    
    <cffunction name="GetHeader" access="private"  returntype="string">
    	<cfargument name="tag" type="struct" required="yes">
        
        <cfset stemp = tag.Title>
        <cfif arguments.tag.Format eq 'money'>
        	<cfset stemp = '<div align="right">#stemp#</div>'>
        </cfif>
        
        <cfreturn stemp>
    </cffunction>
    
    <cffunction name="BuildBody" access="public" returntype="string">
    
    	<cfset var stemp = '<tbody>'>
        
        <cfset qGrid = getGridData()>
        
        <cfloop query="qGrid">
        	<cfset stemp = stemp & '<tr>'>
            <cfloop array="#this.GridAssoAttr#" index="tagInfo">
                <cfif tagInfo.TagName eq "Column">
                	<cfset data = "qGrid.#tagInfo.Field#">
                    <cfset stemp = stemp & '<td>#GetData(data,tagInfo.Format)#</td>'>
                </cfif>
                <cfif tagInfo.TagName eq "Command"> 
                    <cfset stemp = stemp & '<td><a href="#tagInfo.Link#">#tagInfo.Title#</a></td>'>
                </cfif>
            </cfloop>
            <cfset stemp = stemp & '</tr>'>
        </cfloop>
        
        <cfset stemp = stemp & '</tbody></table>'>
        
    	<cfreturn stemp>    	
    </cffunction>
    
    <cffunction name="getGridData" returntype="query" access="private">
    	
        <cfset var qGrid = QueryNew('id')>
          
        <!--- paging control --->
        <cfset StartRow = calculateCurrentPage(this.CurrentPage,this.GridAttr.PageSize) >
        <cfset limit = "LIMIT #StartRow#,#this.GridAttr.PageSize#">
         
        <cfswitch expression="#this.GridAttr.Datasource#">
        	<cfcase value="mysql">
            	<cfquery name="qGrid" datasource="#this.GridAttr.dsn#">
                	#this.GridAttr.DataProvider#
                    #limit#
                </cfquery>                
            </cfcase>
        </cfswitch>
         
        <cfreturn qGrid>
    </cffunction> 
    
    <cffunction name="getData" access="private" returntype="string">
    	<cfargument name="data" type="any" required="yes">
        <cfargument name="format" type="string" required="yes" default="string">
        
        <cfset var stemp = "">
        <cfset stemp = evaluate(arguments.data)>
        <cfswitch expression="#ListFirst(arguments.format,':')#">
        	<cfcase value="email"><cfset stemp = '<a href="mailto:#stemp#">#stemp#</a>'></cfcase>
            <cfcase value="money"><cfset stemp = getMoneyFormat(val(stemp))></cfcase>
            <cfcase value="date"><cfset stemp = '#DateFormat(stemp,ListLast(arguments.format,':'))#'></cfcase>
        </cfswitch>
        
        <cfreturn stemp>
    </cffunction>
    
    <cffunction access="private" name="getMoneyFormat" returntype="string">
    	<cfargument name="data" type="numeric" required="yes">
        
        <cfset var stemp = "">
        <cfif arguments.data gt -1>
        	<cfset stemp = '<div align="right">#NumberFormat(arguments.data,"_,___.__")#</div>'>
        <cfelse>
        	<cfset stemp = '<div style="color:red;" align="right">#NumberFormat(arguments.data,"_,___.__")#</div>'>
        </cfif>
        
        <cfreturn stemp>
    </cffunction>
    
    <cffunction name="calculateCurrentPage" access="private" returnttype="Numeric" output="false" hint="Determine the current page">
        <cfargument name="cp" type="Numeric" required="false" default="1" />
        <cfargument name="mr" type="Numeric" required="false" default="99999999" />
        <cfif arguments.cp eq 1>
            <cfset arguments.cp = 0 />
        <cfelse>
            <cfset arguments.cp = (arguments.cp - 1) * arguments.mr />
        </cfif>
        <cfreturn arguments.cp />
        
    </cffunction>
</cfcomponent>