<cfcomponent displayname="Set Data Controller">
	
    <cffunction name="init" access="public" returntype="SetDataCtrl">
    	<cfargument name="Attribs" required="yes" type="Array" />
        
        <cfset this.DataAttribs = Attribs />
        <cfset this.colorCtrl = createObject('component','com.adexfe.util.UI.color').init() />
        <cfreturn this /> 
    </cffunction>
    
    <cffunction name="buildSetData" access="public" returntype="string">
    	
        <cfset var  xTemp = "" />
        <cfloop array="#this.DataAttribs#" index="tagInfo">
            <cfloop query="tagInfo.QueryName">
                <cfset xTemp = ListAppend(xTemp,"<set label='#Evaluate(tagInfo.Label)#' value='#Evaluate(tagInfo.Value)#' #getColor(CurrentRow,tagInfo)# #getToolTip(CurrentRow,tagInfo)# #getlink(CurrentRow,tagInfo)# showName='#tagInfo.ShowName#' />"," ") />
            </cfloop>
        </cfloop>
        
        <cfreturn xTemp />
    </cffunction>
    
    <cffunction name="getLink" access="private" returntype="string">
    	<cfargument type="numeric" name="QuerPos" required="yes" />
        <cfargument type="struct" name="tagInfo" required="yes" />
        
        <cfset var ttip = ""/>
        <!--- find any instance of a col in the string --->
        <cfif Len(tagInfo.Link)>
        	<cfset ttip = RelaceStringWithQueryValue(tagInfo.QueryName,arguments.QueryPos,tagInfo.Link) />
            <cfset ttip = "link='#ttip#'" />        	
        </cfif>        
        
        <cfreturn ttip/>
    </cffunction>
    
    <cffunction name="getToolTip" access="private" returntype="string">
    	<cfargument type="numeric" name="QuerPos" required="yes" />
        <cfargument type="struct" name="tagInfo" required="yes" />
        
        <cfset var ttip = ""/>
        <!--- find any instance of a col in the string --->
        <cfif Len(tagInfo.ToolTip)>
        	<cfset ttip = RelaceStringWithQueryValue(tagInfo.QueryName,arguments.QueryPos,tagInfo.ToolTip) />
            <cfset ttip = "toolTip='#ttip#'" />        	
        </cfif>        
        
        <cfreturn ttip/>
    </cffunction>
    
    <cffunction name="RelaceStringWithQueryValue" access="private" returntype="string">
    	<cfargument name="qTemp" required="yes" type="query" />
        <cfargument name="QueryPos" required="yes" type="numeric" />
        <cfargument name="strTemp" required="yes" type="string" /> 
        
        <cfloop list="#arguments.qTemp.ColumnList#" index="itm">
        	<cfset itmCol = "[itm]" />
            <cfif FindNoCase(itmCol,arguments.strTemp)>
            	<cfset strQueryValue = "qTemp.itm[#arguments.QueryPos#]" />
				<cfset arguments.strTemp = ReplaceNocase(arguments.strTemp,itmCol,Evaluate(strQueryValue)) />
            </cfif>
        </cfloop>
        
    	<cfreturn arguments.strTemp />    
    </cffunction>
    
    <cffunction name="getColor" access="private" returntype="string">
    	<cfargument name="QueryPos" type="numeric" required="yes" />
        <cfargument type="struct" name="tagInfo" required="yes" />
        
        <cfset var sTemp = "" />
        <!--- check if color was passed from the setdata tag --->
        <cfif Len(tagInfo.Color)>
        	<!--- check if the passed color is in query list --->
        	<cfif ListFindNoCase(tagInfo.QueryName.ColumnList,tagInfo.Color)>
            	<cfset sTemp = "tagInfo.QueryName.#tagInfo.Color#[#QueryPos#]" />
                <cfset sTemp = "color='#Evaluate(sTemp)#'" />
            <cfelse>
            	<!--- the passed color is actually a color --->
            	<cfset sTemp = "color='#tagInfo.Color#'" />
            </cfif>
        <!--- nothing was passed. so i will create mine --->
        <cfelse>
         	<cfset sTemp = "color='#this.colorCtrl.RandColor()#'" />
        </cfif>
        
        <cfreturn sTemp />
    </cffunction>
    
</cfcomponent>