<cfcomponent>

	<cffunction name="init" access="remote" returntype="GridSettingCtrl"> 
    	<cfargument name="table" default="" />
    	<cfargument name="dsn" default="" type="string" />
       
    	<cfset this.dsn = arguments.dsn >
        <cfset this.table = arguments.table >
        <cfset this.gridId = 0 >
        
    	<cfreturn this >
    </cffunction>
    
    <cffunction access="private" name="convertToGridTypeName" returntype="string">
    	<cfargument name="typeName" required="yes" />
        <cfset var stemp = "" />
        <cfswitch expression="#arguments.typeName#">
        	<cfcase value="date,datetime" delimiters=",">
            	<cfset stemp = "date:d-m-y" />
            </cfcase>
            <cfcase value="tinyint,int,mediumint,smallint,bigint">
            	<cfset stemp = "integer" />
            </cfcase>
            <cfcase value="double">
            	<cfset stemp = "money" />
            </cfcase>
            <cfcase value="text">
            	<cfset stemp = "longtext" />
            </cfcase>
            <cfdefaultcase>
            	<cfset stemp = "string" />
            </cfdefaultcase>
        </cfswitch>
        <cfreturn stemp />
    </cffunction>
    
    <cffunction name="getColumnType" access="public" returntype="string">
    	<!--- get the dbinfo --->
        <cfset var lstColType = "" />
        <cfdbinfo datasource="#this.dsn#" type="columns" table="#this.table#" name="qTable"  />
    	<cfloop list="#this.ColumnValue#" index="col">
        	<cfquery name="qCol" dbtype="query">
            	SELECT * FROM qTable WHERE COLUMN_NAME = '#col#'
            </cfquery>
            <cfset lstColType = listAppend(lstColType,convertToGridTypeName(qCol.TYPE_NAME)) />
        </cfloop>
    	<cfreturn lstColType />
    </cffunction>
    
    <cffunction name="ajGetGridView" access="remote" returntype="array">
    	<cfargument name="GridKey" required="yes" />
        <cfargument name="Selected" required="yes" />
        <cfargument name="dsn" required="yes" >
        
        <cfset init('',arguments.dsn) /> 
        
        <cfquery name="qTemp" datasource="#this.dsn#">
        	SELECT ViewName,GridViewId 
            FROM vw_grid_view WHERE GridKey = <cfqueryparam value="#arguments.GridKey#" cfsqltype="cf_sql_varchar" />
        </cfquery>
        <cfquery name="qSel" dbtype="query">
        	SELECT * FROM qTemp WHERE GridViewId = #arguments.Selected#
        </cfquery>
        <cfquery name="qRem" dbtype="query">
        	SELECT * FROM qTemp WHERE GridViewId <> #arguments.Selected#
        </cfquery>
        <cfset i=0/>
        <cfset a=ArrayNew(2) />
        <cfif qSel.RecordCount>
			<cfset i=1/>
			<cfset a[1][1] = qSel.GridViewId />
            <cfset a[1][2] = qSel.ViewName />
        </cfif>
        <cfloop query="qRem" >
        	<cfset i=i+1 />
        	<cfset a[i][1] = GridViewId />
            <cfset a[i][2] = ViewName />
        </cfloop>
        <cfreturn a />
    </cffunction>
    
	<cffunction name="isGridExist" access="private" returntype="boolean">  
        
        <cfquery name="qTemp" datasource="#this.dsn#">
        	SELECT GridKey,GridId FROM grid WHERE GridKey = <cfqueryparam cfsqltype="cf_sql_varchar" value="#this.GridKey#"/>
        </cfquery>
        <cfset this.gridid = val(qTemp.gridid) />
        
        <cfif Not(qTemp.RecordCount)>
			<!--- create the grid --->	
            <cftransaction>
                <cfquery datasource="#this.dsn#" >
                    INSERT INTO grid (GridKey) VALUES (<cfqueryparam cfsqltype="cf_sql_varchar" value="#this.GridKey#"/>)
                </cfquery>
                <cfquery name="getLastGrid" datasource="#this.dsn#">
                    SELECT MAX(@@IDENTITY) AS Id FROM grid
                </cfquery>
            </cftransaction>
            <cfset this.gridid = val(getLastGrid.id) />
        </cfif>    
		<cfreturn qTemp.RecordCount />
	</cffunction>
    
    <cffunction name="save" access="remote" returntype="void">
    	<cfargument name="GridKey" required="yes" />
    	<cfargument name="ViewName" required="yes" />
        <cfargument name="ReportTitle" default="" />
        <cfargument name="ViewTitle" required="yes" />
        <cfargument name="ColumnName" required="yes" />
        <cfargument name="ColumnValue" required="yes" />
        <cfargument name="UserId" required="yes" />
        <cfargument name="InsertType" required="yes" />
        <cfargument name="GridViewId" required="yes" />
        
        <cfscript>
		
		if (Not(structkeyexists(this,'dsn')))	{
			init('officemod');
		}
		this.GridKey = arguments.GridKey;
		this.ViewName = arguments.ViewName;
		this.ReportTitle = arguments.ReportTitle;
		this.ViewTitle = arguments.ViewTitle;
		this.ColumnName = arguments.ColumnName;
		this.ColumnValue = arguments.ColumnValue;
		this.UserId = arguments.UserId;
		this.InsertType = arguments.InsertType;
		this.GridViewId = arguments.GridViewId;
		this.ColumnType = getColumnType();
		
		if (isGridExist())	{update();}
		else	{add();}
		
		</cfscript>
        
    </cffunction>
    
    <cffunction name="update" access="private" returntype="void"> 
      
        <cfswitch expression="#this.InsertType#">
        	<cfcase value="new">
				<cfset add() />
            </cfcase >
            <cfcase value="edit">
                <cfquery datasource="#this.dsn#" >
                    UPDATE grid_view SET 
                        ViewName = <cfqueryparam value="#this.ViewName#" cfsqltype="cf_sql_varchar" />,
                        ReportTitle = <cfqueryparam value="#this.ReportTitle#" cfsqltype="cf_sql_varchar" />,
                        ViewTitle = <cfqueryparam value="#this.ViewTitle#" cfsqltype="cf_sql_varchar" />,
                        ColumnName = <cfqueryparam value="#this.ColumnName#" cfsqltype="cf_sql_varchar" />,
                        ColumnType = <cfqueryparam value="#this.ColumnType#" cfsqltype="cf_sql_varchar" />,
                        ColumnValue = <cfqueryparam value="#this.ColumnValue#" cfsqltype="cf_sql_varchar" />
                    WHERE GridId = #this.GridId# AND GridViewId = #this.GridViewId#            
                </cfquery>
            </cfcase>
        </cfswitch>
        
    </cffunction>
    
    <cffunction name="add" access="private" returntype="void">  
    
        <cfquery datasource="#this.dsn#" >
            INSERT INTO grid_view (
                ViewName,ReportTitle,ViewTitle,ColumnType,
                ColumnName,ColumnValue ,GridId,UserId
            )
            VALUES	( 
                <cfqueryparam value="#this.ViewName#" cfsqltype="cf_sql_varchar" />,
                <cfqueryparam value="#this.ReportTitle#" cfsqltype="cf_sql_varchar" />,
                <cfqueryparam value="#this.ViewTitle#" cfsqltype="cf_sql_varchar" />,
                <cfqueryparam value="#this.ColumnType#" cfsqltype="cf_sql_varchar" />,
                <cfqueryparam value="#this.ColumnName#" cfsqltype="cf_sql_varchar" />,
                <cfqueryparam value="#this.ColumnValue#" cfsqltype="cf_sql_varchar" />,
                #this.GridId#,#this.userid#
            )             
        </cfquery>
        
    </cffunction>
    
</cfcomponent>