<cfcomponent>

	<cffunction name="init" access="public" returntype="Report">
		<cfargument name="GridAttr" type="struct" required="yes">
        <cfargument name="GridAssoAttr" type="array" required="yes">
        <cfargument name="url_" type="struct" required="yes">
		
		<cfset this.GridAttr = arguments.GridAttr>
        <cfset this.GridAssoAttr = arguments.GridAssoAttr>
        <cfset this.url = GetQueryStringPart(arguments.url_.QueryString)> 
        
        <cfset this.QueryString = ""> 
        <cfset this.ImagePath = "#this.GridAttr.GridDataPath#skin/#this.GridAttr.Skin#/images/">
        <cfset this.exportPath = "#this.GridAttr.GridDataPath#export/">
		<!--- BuildHeader function will set this count --->
		<cfset this.ColumnCount = 0>
        <cfset this.CommandCount = 0>
        <cfset this.lstColumnField = "">
        <cfset this.lstColumnTitle = "">
         
		<cfreturn this>
	</cffunction>
    
    <cffunction name="BuildHeader" access="public" returntype="string"> 
    
    	<cfset var stemp = '<style>body,table{ font:11px "Trebuchet MS",Arial; background: ##FFF; } th{background:##eee;border-bottom:2px ##333 solid;padding-left:1px;} td{ border-bottom:1px solid ##CCC; padding:1px; } th,td{ padding-left:2px; text-align: left; } .header{text-decoration:underline;text-align:center;font-weight:bold;font-size:13px;padding-bottom:10px;display:block;text-transform:uppercase;}</style><div class="header">#this.GridAttr.ReportTitle#</div><table width="100%" border="0" cellspacing="0" cellpadding="0" ><thead><tr>'>
        <cfset var stemp2 = "">
        <cfset var sTbar = "">
		<cfloop array="#this.GridAssoAttr#" index="tagInfo">
        	<cfswitch expression="#tagInfo.TagName#"> 
            	<cfcase value="Column">  
            		<cfset stemp2 = stemp2 & '<th align="left">#GetHeader(tagInfo)#</th>'>
                    <cfset this.ColumnCount = 1 + this.ColumnCount>
                    <cfset this.lstColumnField = ListAppend(this.lstColumnField,tagInfo.Field)>
                    <cfset this.lstColumnTitle = ListAppend(this.lstColumnTitle,tagInfo.Title)>
            	</cfcase>  
            </cfswitch>
        </cfloop>
         
        <cfset stemp = stemp & '<tr>' & stemp2>  
               
        <cfset stemp = stemp & '</tr></thead>'>
        
    	<cfreturn stemp>    	
    </cffunction> 
     
    <cffunction name="GetHeader" access="private"  returntype="string">
    	<cfargument name="tag" type="struct" required="yes">
        
        <cfset stemp = tag.Title>
        <cfif arguments.tag.Format eq 'money'>
        	<cfset stemp = '<div align="right">#stemp#</div>'>
        </cfif>
        
        <cfreturn stemp>
    </cffunction>
    
    <cffunction name="getQueryString" access="public" returntype="string">
    	
        <cfreturn "pn=#this.url.pn#&sortby=#this.url.sortby#&order=#this.url.order#">
    </cffunction>
    
    <cffunction name="BuildBody" access="public" returntype="string">
    
    	<cfset var stemp = '<tbody >'>
        <cfset var i = 0>
        <cfset qGrid = getGridData()>
		<cfset scommd = "">  
        <cfloop query="qGrid">
        	<cfset i = i + 1> 
        	<cfset stemp = stemp & '<tr valign="top">'> 
            <cfloop array="#this.GridAssoAttr#" index="tagInfo">
                <cfif tagInfo.TagName eq "Column"> 
                	<cfset data = "qGrid.#tagInfo.Field#">
                    <cfset stemp = stemp & '<td>#GetData(data,tagInfo.Format)#</td>'>
                </cfif>
            </cfloop>
            <!--- run tag lookup seperately so that the command will always be at the end --->
            
            <cfset stemp = stemp & '</tr>'>
        </cfloop> 
               
        <cfset stemp = stemp & '</tbody></table>'>
        
    	<cfreturn stemp>    	
    </cffunction>
    
    <cffunction name="getGridData" returntype="query" access="private">
    	
        <cfset var qGrid = QueryNew('id')>
         
        
        <!--- sorting control --->
        <cfswitch expression="#this.GridAttr.DataProvider#">
        	<cfcase value="mysql">
            	<cfquery name="qGrid" datasource="#this.GridAttr.Datasource#">
                	#this.GridAttr.SQL#
                    <!--- check if user is searching, then search --->
					<cfif this.url.keyword neq "">
                    	<cfif FindNoCase('WHERE',this.GridAttr.SQL) gt 0>
                        	AND                        	
                        <cfelse>
                        	WHERE
                        </cfif>
                        #this.url.search_by# 
                        <cfswitch expression="#this.url.operator#">
                        	<cfcase value="is_equal_to">
                            	= <cfqueryparam value="#this.url.keyword#" cfsqltype="cf_sql_varchar">
                            </cfcase>
                            <cfcase value="contains">
                            	LIKE <cfqueryparam value="%#this.url.keyword#%" cfsqltype="cf_sql_varchar">
                            </cfcase>
                        </cfswitch>
                    </cfif>
                    <!---//end search --->
					<cfif this.url.sortby neq "">
                    	order by #this.url.sortby#
						<cfif this.url.order neq "">
                            #this.url.order#
                        </cfif> 
                    </cfif> 
                </cfquery>                
            </cfcase>
            <cfcase value="query">
            	<cfquery name="qGrid" dbtype="query">
                    SELECT * FROM
                    this.GridAttr.Query
                    <!--- check if user is searching, then search --->
					<cfif this.url.keyword neq ""> 
                        WHERE lower(#this.url.search_by#)
                        <cfswitch expression="#this.url.operator#">
                        	<cfcase value="is_equal_to">
                            	= <cfqueryparam value="#lcase(this.url.keyword)#" cfsqltype="cf_sql_varchar">
                            </cfcase>
                            <cfcase value="contains">
                            	LIKE <cfqueryparam value="%#lcase(this.url.keyword)#%" cfsqltype="cf_sql_varchar">
                            </cfcase>
                        </cfswitch>
                    </cfif>
                    <!---//end search --->
                    <CFIF this.url.sortby NEQ "">
                        order by #this.url.sortby#
                        <cfif this.url.order neq "">
                            #this.url.order#
                        </cfif>
                    </CFIF>
                </cfquery> 
            </cfcase>
        </cfswitch>  
        
        <cfreturn qGrid>
    </cffunction> 
    
    <cffunction name="getData" access="private" returntype="string">
    	<cfargument name="data" type="any" required="yes">
        <cfargument name="format" type="string" required="yes" default="string">
        
        <cfset var stemp = "">
        
		<cftry>
			<cfset stemp = evaluate(arguments.data)>
			<cfcatch type="expression">
				<cfthrow errorcode="41211" message="[#listlast(arguments.data,'.')#] is not defined in the Dataprovider." >
        	</cfcatch>
        </cftry>
        <cfswitch expression="#ListFirst(arguments.format,':')#"> 
            <cfcase value="money"><cfset stemp = getMoneyFormat(val(stemp))></cfcase>
            <cfcase value="date"><cfset stemp = '#DateFormat(stemp,ListLast(arguments.format,':'))#'></cfcase>
            <cfcase value="url,website" delimiters=","><cfset stemp = '#replacenocase(stemp,"http://","")#'></cfcase> 
        </cfswitch>
        
        <!---<cfif stemp eq ""><cfset stemp = "&nbsp;"></cfif>--->
        
        <cfreturn stemp & "&nbsp;">
    </cffunction>
    
    <cffunction access="private" name="getMoneyFormat" returntype="string">
    	<cfargument name="data" type="numeric" required="yes">
        
        <cfset var stemp = "">
        <cfif arguments.data gt -1>
        	<cfset stemp = '<div align="right">#NumberFormat(arguments.data,"_,___.__")#</div>'>
        <cfelse>
        	<cfset stemp = '<div style="color:red;" align="right">#NumberFormat(arguments.data,"_,___.__")#</div>'>
        </cfif>
        
        <cfreturn stemp>
    </cffunction>
    
    <cffunction name="calculateCurrentPage" access="private" returnttype="Numeric" output="false" hint="Determine the current page">
        <cfargument name="cp" type="Numeric" required="false" default="1" />
        <cfargument name="mr" type="Numeric" required="false" default="99999999" />
        <cfif arguments.cp eq 1>
            <cfset arguments.cp = 0 />
        <cfelse>
            <cfset arguments.cp = (arguments.cp - 1) * arguments.mr />
        </cfif>
        <cfreturn arguments.cp />
        
    </cffunction>
    
    <cffunction name="GetQueryStringPart" access="private" returntype="struct">
    	<cfargument name="qs" required="yes" type="string"> 
        
        <cfset var stemp = StructNew()> 
        <cfloop list="#arguments.qs#" index="urlval" delimiters="&">
        	<cfif ListLen(urlval,'=') eq 2>
        		<cfset st = ListGetAt(urlval,1,'=')>
        		<cfset stemp[st] = URLDecode(ListGetAt(urlval,2,'='))>
            </cfif>
        </cfloop>
        <cfparam name="stemp.pn" default="1">
        <cfparam name="stemp.sortby" default="">
        <cfparam name="stemp.order" default="asc">
        <cfparam name="stemp.keyword" default="">
        <cfparam name="stemp.operator" default=""> 
        <cfparam name="stemp.search_by" default="">
        
        <cfreturn stemp>
	</cffunction>
    
</cfcomponent>