<cfcomponent>

	<cffunction name="init" access="public" returntype="List">
    
    	<cfreturn this />
    </cffunction>
    
    <cffunction name="ListToQuery" access="public" returntype="query">
        <cfargument name="Cols" type="string" required="yes" />
        <cfargument name="lstArg" type="string" required="yes" />
        
        <cfset var qTemp = QueryNew(cols) />
        <cfloop list="#lstArg#" index="lstItem">
            <cfset QueryAddRow(qTemp) />
            <cfset QuerySetCell(qTemp,"#Cols#",lstItem) /> 
        </cfloop>
        
        <cfreturn qTemp />
    </cffunction>
    
    <cffunction name="ListDistinct" access="public" returntype="string">
        <cfargument name="List" type="string" required="yes" />
        <cfargument name="delimiter" type="string" default=","/>
        
		<cfset qTemp = ListToQuery('ListItem',List) />
        <cfquery name="qList" dbtype="query">
        	SELECT DISTINCT(ListItem) FROM qTemp
        </cfquery>
       	
        <cfreturn QueryToList(qList,'ListItem') />
    </cffunction>
    
    <cffunction name="ListDistinctNoCase" access="public" returntype="string">
        <cfargument name="List" type="string" required="yes" />
        <cfargument name="delimiter" type="string" default=","/>
        
		<cfset qTemp = ListToQuery('ListItem',LCase(List)) />
        <cfquery name="qList" dbtype="query">
        	SELECT DISTINCT(ListItem) FROM qTemp
        </cfquery>
       	
        <cfreturn ValueList(qList.ListItem) />
    </cffunction>
    
    <cffunction name="QueryToList" access="public" returntype="string">
        <cfargument name="Query" type="query" required="yes" />
        <cfargument name="Column" type="string" required="yes" />
        <cfargument name="delimiter" type="string" default=","/>
        
        <cfset sList = "" >
		<cfloop query="Query">
        	<cfset sList = ListAppend(sList,evaluate(Column),delimiter) />
        </cfloop>
       	
        <cfreturn sList />
    </cffunction>
    
</cfcomponent>