<cfcomponent output="false" extends="com.adexfe.officemod.connection" displayname="OMS Trade">

    
	
	<cffunction name="getUser" output="false" access="remote">
		<cfargument name="ClOrdId" type="string" required="true" />
		
		<cfset var q = "" />
		
		<cfquery name="q" datasource="lambeth">
			SELECT ClOrdId,Side,AccountCSCSNo,SecurityId,Quantity,Authorised,Sent,Price_44
			FROM newordersingle 
			WHERE ClOrdId = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ClOrdId#">
		</cfquery>
		
		<cfreturn q />
	</cffunction>


	<cffunction name="saveUser" output="false" access="remote">
		<cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="AccountCSCSNo" type="string" required="true" />
		<cfargument name="SecurityId" type="string" required="true" />
		<cfargument name="Quantity" type="numeric" required="true" />
		<cfargument name="Price_44" type="any" required="true" />
		
		<cfif arguments.ClOrdId NEQ "">
			<cfset updateUser(argumentCollection = arguments) />
		</cfif>
	</cffunction>
	
	<cffunction name="createUser" output="false" access="private" returntype="any" hint="">
		<cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="Side" type="string" required="no" />
		<cfargument name="AccountCSCSNo" type="string" required="no" />
		<cfargument name="SecurityId" type="string" required="no" />
		<cfargument name="Quantity" type="numeric" required="true" />
		<cfargument name="Price_44" type="any" required="true" />
		
		<cfquery datasource="lambeth">
		INSERT INTO newordersingle (ClOrdId,Side,AccountCSCSNo,OrderType,SecurityId,Quantity,Price_44)
		VALUES (<cfqueryparam value="#ClOrdId#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.Side#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.AccountCSCSNo#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.OrderType#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.SecurityId#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.Quantity#" cfsqltype="cf_sql_integer">),
				<cfqueryparam value="#arguments.Price_44#" cfsqltype="cf_sql_float" >)
	</cfquery>
	</cffunction>
	
	<cffunction name="updateUser" output="false" access="private" returntype="any" hint="">
		<cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="Side" type="string" required="no" />
		<cfargument name="AccountCSCSNo" type="string" required="no" />
		<cfargument name="SecurityId" type="string" required="no" />
		<cfargument name="Quantity" type="numeric" required="true" />
		<cfargument name="Price_44" type="any" required="true" />
		
		<cfquery datasource="lambeth">
			UPDATE newordersingle
			SET  
				AccountCSCSNo = <cfqueryparam value="#arguments.AccountCSCSNo#" cfsqltype="cf_sql_varchar" />,
        		SecurityId = <cfqueryparam value="#arguments.SecurityId#" cfsqltype="cf_sql_varchar" />, 
        		Quantity = <cfqueryparam value="#arguments.Quantity#" cfsqltype="cf_sql_integer" />, 
                Price_44 = <cfqueryparam value="#arguments.Price_44#" cfsqltype="cf_sql_double" />
				WHERE ClOrdId = <cfqueryparam value="#arguments.ClOrdId#" cfsqltype="cf_sql_varchar">
		</cfquery>
	</cffunction>


	<cffunction name="getAllUsers" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qRead="">

		<cfquery name="qRead" datasource="lambeth">
			SELECT ClOrdId,Side,AccountCSCSNo,OrderType,SecurityId,Quantity,Price_44,Authorised,Sent,TimInForce
			FROM	newordersingle where Authorised = 'false' 
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
			ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
			ORDER BY SecurityId ASC
			</cfif>
		</cfquery>

		<cfreturn queryConvertForGrid(qRead, cfgridpage, cfgridpageSize) />
	</cffunction>

</cfcomponent>