<cfcomponent output="false">
	
	<cffunction name="getUser" output="false" access="remote">
		<cfargument name="ClOrdId" type="string" required="true" />
		
		<cfset var q = "" />
		
		<cfquery name="q" datasource="lambeth">
			SELECT ClOrdId, Side, AccountCSCSNo, SecurityId, Quantity, Price_44,Authorised,Sent
			FROM newordersingle
			WHERE ClOrdId = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ClOrdId#">
		</cfquery>
		
		<cfreturn q />
	</cffunction>

	<cffunction name="getAckNew" output="false" access="remote">
		<cfargument name="ClOrdId" type="string" required="true" />
		
		<cfset var q = "" />
		
		<cfquery name="q" datasource="lambeth">
			SELECT ClOrdId, OrigClOrdId, Side, AccountCSCSNo, SecurityId, OrderQty, LeavesQty, CumQty, LastPx
			FROM executionreport
            WHERE ClOrdId = <cfqueryparam cfsqltype="cf_sql_varchar" value="#arguments.ClOrdId#"> 
		</cfquery>
		
		<cfreturn q />
	</cffunction>


	<cffunction name="saveUser" output="false" access="remote">
		<cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="Side" type="string" required="true" />
		<cfargument name="AccountCSCSNo" type="string" required="true" />
		<cfargument name="SecurityId" type="string" required="true" />
		<cfargument name="Quantity" type="any" required="true" />
		<cfargument name="Price_44" type="any" required="true" />
		
		<cfif arguments.ClOrdId EQ "">
			<cfset createUser(argumentCollection = arguments) />
		<cfelse>
			<cfset updateUser(argumentCollection = arguments) />
		</cfif>
	</cffunction>
	
	<cffunction name="reqReplace" output="false" access="private" returntype="any" hint="">
	   	<cfargument name="ClOrdId" type="string" required="true" />
	   	<cfargument name="OrigClOrdId" type="string" required="true" />
		<cfargument name="Side" type="string" required="true" />
		<cfargument name="AccountCSCSNo" type="string" required="true" />
		<cfargument name="SecurityId" type="string" required="true" />
		<cfargument name="Authorised" type="any"  required="true" />
		<cfargument name="Sent" type="any" required="true" />
		<cfargument name="Quantity" type="any" required="true" />
		<cfargument name="Price" type="any" required="true" />
		
		<cfquery datasource="lambeth">
		INSERT INTO ordercancelreplacerequest (ClOrdId,OrigClOrdId,Side,AccountCSCSNo,SecurityId,Quantity,Price,Authorised,Sent)
		VALUES (<cfqueryparam value="#arguments.ClOrdId#" cfsqltype="cf_sql_varchar">,
        		<cfqueryparam value="#arguments.OrigClOrdId#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.Side#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.AccountCSCSNo#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.SecurityId#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.Quantity#" cfsqltype="cf_sql_integer" >,
                <cfqueryparam value="#arguments.Price#" cfsqltype="cf_sql_double" >,
                <cfqueryparam value="#arguments.Authorised#" cfsqltype="cf_sql_tinyint"  >,
                <cfqueryparam value="#arguments.Price_44#" cfsqltype="cf_sql_tinyint"  >  )
	</cfquery>
	</cffunction>


	<cffunction name="createUser" output="false" access="private" returntype="any" hint="">
	   <cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="Side" type="string" required="true" />
		<cfargument name="AccountCSCSNo" type="string" required="true" />
		<cfargument name="SecurityId" type="string" required="true" />
		<cfargument name="Quantity" type="any" required="true" />
		<cfargument name="Price_44" type="any" required="true" />
		
		<cfquery datasource="lambeth">
		INSERT INTO newordersingle (ClOrdId,Side,AccountCSCSNo,SecurityId,Quantity,Price_44)
		VALUES (<cfqueryparam value="#arguments.ClOrdId#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.Side#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.AccountCSCSNo#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.SecurityId#" cfsqltype="cf_sql_varchar">,
				<cfqueryparam value="#arguments.Quantity#" cfsqltype="cf_sql_integer" >,
                <cfqueryparam value="#arguments.Price_44#" cfsqltype="cf_sql_double" >
	</cfquery>
	</cffunction>
	
	<cffunction name="updateUser" output="false" access="private" returntype="any" hint="">
	   <cfargument name="ClOrdId" type="string" required="true" />
		<cfargument name="Side" type="string" required="true" />
		<cfargument name="AccountCSCSNo" type="string" required="true" />
		<cfargument name="Authorised" type="string" required="no" />
		<cfargument name="SecurityId" type="string" required="true" />
		<cfargument name="Quantity" type="any" required="true" />
		<cfargument name="Price_44" type="any" required="true" />
		
		<cfquery datasource="lambeth">
			UPDATE newordersingle
			SET 
			Authorised = <cfqueryparam value="#arguments.Authorised#" cfsqltype="cf_sql_integer">,
			Quantity = <cfqueryparam value="#arguments.Quantity#" cfsqltype="cf_sql_integer">,
			Price_44 = <cfqueryparam value="#arguments.Price_44#" cfsqltype="cf_sql_double">
			WHERE ClOrdId = <cfqueryparam value="#arguments.ClOrdId#" cfsqltype="cf_sql_varchar">
		</cfquery>
	</cffunction>

	<cffunction name="getAllUsers" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qRead="">

		<cfquery name="qRead" datasource="lambeth">
			SELECT ClOrdId, Side, AccountCSCSNo, SecurityId, Quantity, Price_44
			FROM	newordersingle
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
			ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
			ORDER BY SecurityId ASC
			</cfif>
		</cfquery>

		<cfreturn queryConvertForGrid(qRead, cfgridpage, cfgridpageSize) />
	</cffunction>

	<cffunction name="getUnAppUsers" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qRead="">

		<cfquery name="qRead" datasource="lambeth">
			SELECT ClOrdId, Side, AccountCSCSNo, SecurityId, Quantity, Price_44,Authorised,Sent
			FROM	newordersingle where Authorised = 0 and Sent = 0
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
			ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
			ORDER BY SecurityId ASC
			</cfif>
		</cfquery>
        <cfset queryAddColumn(qRead, "approve ", arrayNew(1))>
		<cfloop query="qRead">
			<cfset querySetCell(qRead, "approve ", "<input value='approve ' type='button' onclick='javascript:approveMe(#ClOrdId#)'>", currentrow)>
		</cfloop>
        
		<cfreturn queryConvertForGrid(qRead, cfgridpage, cfgridpageSize) />
        
	</cffunction>

	<cffunction name="getAppUsers" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qApp="">

		<cfquery name="qApp" datasource="lambeth">
			SELECT ClOrdId, Side, AccountCSCSNo, SecurityId, Quantity, Price_44,Authorised,Sent
			FROM	newordersingle where Authorised = 1 and Sent = 0
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
				ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
				ORDER BY SecurityId ASC
			</cfif>
		</cfquery>
        <cfset queryAddColumn(qApp, "modify ", arrayNew(1))>
		<cfloop query="qApp">
			<cfset querySetCell(qApp, "modify ", "<input value='modify ' type='button' onclick='javascript:modifyMe(#ClOrdId#)'>", currentrow)>
		</cfloop>
        
		<cfreturn queryConvertForGrid(qApp, cfgridpage, cfgridpageSize) />
        
	</cffunction>

	<cffunction name="getAckTrades" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qAck="">

		<cfquery name="qAck" datasource="lambeth">
			SELECT * FROM executionreport where OrdStatus = 'NEW' AND ExecType = 'NEW'
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
				ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
				ORDER BY SecurityId ASC
			</cfif>
		</cfquery>
        
        <cfset queryAddColumn(qAck, "amend ", arrayNew(1))>
		<cfloop query="qAck">
			<cfset querySetCell(qAck, "amend ", "<input value='amend ' type='button' onclick='javascript:amendMe(#ClOrdId#)'>", currentrow)>
		</cfloop>
        
		<cfreturn queryConvertForGrid(qAck, cfgridpage, cfgridpageSize) />
        
	</cffunction>

	<cffunction name="getRejTrades" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qRej="">

		<cfquery name="qRej" datasource="lambeth">
			SELECT * FROM executionreport where OrdStatus = 'REJECTED' AND ExecType = 'REJECTED'
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
				ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
				ORDER BY SecurityId ASC
			</cfif>
		</cfquery>
                
		<cfreturn queryConvertForGrid(qRej, cfgridpage, cfgridpageSize) />
        
	</cffunction>

	<cffunction name="getCanTrades" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qCan="">

		<cfquery name="qCan" datasource="lambeth">
			SELECT * FROM executionreport where OrdStatus = 'CANCELLED' AND ExecType = 'CANCELLED'
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
				ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
				ORDER BY SecurityId ASC
			</cfif>
		</cfquery>
                
		<cfreturn queryConvertForGrid(qCan, cfgridpage, cfgridpageSize) />
        
	</cffunction>
	<cffunction name="getPartTrades" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qPart="">

		<cfquery name="qPart" datasource="lambeth">
			SELECT * FROM executionreport where OrdStatus = 'PARTIALLY-FILLED' 
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
				ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
				ORDER BY SecurityId ASC
			</cfif>
		</cfquery>
                
		<cfreturn queryConvertForGrid(qPart, cfgridpage, cfgridpageSize) />
        
	</cffunction>
	<cffunction name="getTrades" output="false" access="remote" returntype="struct">
		<cfargument name="cfgridpage">
		<cfargument name="cfgridpageSize">
		<cfargument name="cfgridsortcolumn"  />
		<cfargument name="cfgridsortdirection"  />

		<cfset var qTrades="">

		<cfquery name="qTrades" datasource="lambeth">
			SELECT * FROM executionreport where ExecType = 'TRADE' 
			<cfif len(arguments.cfgridsortcolumn) and len(arguments.cfgridsortdirection)>
				ORDER BY #arguments.cfgridsortcolumn# #arguments.cfgridsortdirection#
			<cfelse>
				ORDER BY SecurityId ASC
			</cfif>
		</cfquery>
                
		<cfreturn queryConvertForGrid(qTrades, cfgridpage, cfgridpageSize) />
        
	</cffunction>

</cfcomponent>